***
      real*8 FUNCTION mlwind(kw,lum,r,mt,mc,rl,z)
      implicit none
      integer kw
      real*8 lum,r,mt,mc,rl,z,sigma,lgdms,edfac,FOURPI,tem,ind,Xh
      real*8 ad11,ad12,ad13,ad14,ad15,ad21,ad22,ad23,ad24,ad25,ad26
      real*8 ad01,ad02,ad03,ad04,ad31,ad32,ad33,ad34
      real*8 gamma0,beta
      real*8 dml,dms,dmt,p0,x,xx,mew,neta,bwind,mxns
      real*8 lum0,kap,V1,V2,Zsun,eddington
      parameter(lum0=7.0d+04,kap=-0.5d0,V1=1.3d0,V2=2.6d0,Zsun=0.02)
      common /value1/ neta,bwind,mxns
      external eddington
*
* Calculate stellar wind mass loss.
***
* Calculate the effective temperature (tem) by the simple formula:
*     L = 4*pi*T^4*sigma
*
      sigma = 5.67d0*10.d0**(-5.d0)*(6.96d0*10.d0**10.d0)**2.d0
     &        /(3.84d0*10.d0**33.d0)
      FOURPI = 2.d0*ACOS(-1.d0)
      tem = (lum/(FOURPI*r**2.d0*sigma))**(1.d0/4.d0)
*
* Exponent of the dependence on metallicity: (Z/Zsun)^ind
* Dipendence on eddingtin factor taken from Chen (2015)
* Eddington factor is given by eddinton()
      ind = 0.85d0
      edfac = eddington(mt,lum,kw)
      if(1.d0.gt.edfac.and.edfac.gt.2.d0/3.d0)then
         ind = (2.45d0 - 2.4d0*edfac)
      elseif(edfac.gt.1.d0)then
         ind = 0.05d0
      endif
*
***
* Apply mass loss of Nieuwenhuijzen & de Jager, A&A, 1990, 231, 134,
* for massive stars over the entire HRD.
*
      dms = 0.d0
      if(lum.gt.4000.d0)then
         x = MIN(1.d0,(lum-4000.d0)/500.d0)
         dms = 9.6d-15*x*(r**0.81d0)*(lum**1.24d0)*(mt**0.16d0)
         dms = dms*(z/Zsun)**(ind)
      endif
*
* Stellar winds for O/B stars.
*
      if(kw.ge.0 .and. kw.le.1)then
*
* Eqs 25 and 24 in Vink et al. 2001, A&A, 369, 574.
*
          if(12500.d0.le.tem .and. tem.le.25000.d0)then
             ad11 = 2.21d0*Log10(lum/(10.d0**5.d0))
             ad12 = -1.339d0*Log10(mt/30.d0)
* V is the ration of wind velocity at inf to escape velosity.
             ad13 = -1.601d0*Log10(V1/2.d0)
             ad14 = ind*Log10(z/Zsun)
             ad15 = 1.071*Log10(tem/20000.d0)
* logarithm of the mass loss rate.
             lgdms = -6.688d0 + ad11 + ad12 + ad13 + ad14 + ad15
             dms = 10.d0**lgdms
          elseif(25000.d0.lt.tem .and. tem.le.50000.d0)then
             ad21 = 2.194d0*Log10(lum/(10.d0**5.d0))
             ad22 = -1.313d0*Log10(mt/30.d0)
* V is the ration of wind velocity at inf to escape velosity.
             ad23 = -1.226d0*Log10(V2/2.d0)
             ad24 = ind*Log10(z/Zsun)
             ad25 = 0.933d0*Log10(tem/40000.d0)
             ad26 = -10.92d0*(Log10(tem/40000.d0))**2.d0
* logarithm of the mass loss rate
             lgdms = -6.697d0 + ad21 + ad22 + ad23 + ad24 + ad25 +ad26
             dms = 10.d0**lgdms
          endif
      endif
*
***
*
      if(kw.ge.2.and.kw.le.9)then
* 'Reimers' mass loss
         dml = neta*4.0d-13*r*lum/mt
*
* Check for any tidally enhanced mass loss in binary systems (optional):
* see Tout & Eggleton, MNRAS, 1988, 231, 823.
*
         if(rl.gt.0.d0) dml = dml*(1.d0 + bwind*(MIN(0.5d0,(r/rl)))**6)

         dms = max(dms,dml)
*
* Apply mass loss of Vassiliadis & Wood, ApJ, 1993, 413, 641,
* for high pulsation periods on AGB.
*
         if(kw.eq.6)then
            p0 = -2.07d0 - 0.9d0*log10(mt) + 1.94d0*log10(r)
            p0 = 10.d0**p0
            p0 = MIN(p0,2000.d0)
            dmt = -11.4d0+0.0125d0*(p0-100.d0*MAX(mt-2.5d0,0.d0))
            dmt = 10.d0**dmt
            dmt = 1.d0*MIN(dmt,1.36d-09*lum)
            dms = MAX(dms,dmt)
            endif
         if(kw.gt.6)then
*
***
* WR-like mass loss from Belczynski 2010 plus the dependence on 
* metallicity (Giacobbo et al. 2017).
*
            dms = (10.d0**(-13.d0))*(lum**1.5d0)*(z/Zsun)**ind
*
         endif
*
         xx = 1.0d-5*r*sqrt(lum)
         if(lum.gt.6.0d+05.and.xx.gt.1.d0)then
*
* LBV-like mass loss beyond the Humphreys-Davidson limit
* and beyond the MS (it depends on Z)
*
            dms = (z/Zsun)**ind*1.5d0*10.d0**(-4.d0)
*
         endif
      endif
*
      mlwind = dms
*
      return
      end
***

      subroutine initialize(z_in,
     &			    neta_in, bwind_in, hewind_in, sigma1_in,
     &			    sigma2_in, ifflag_in, wdflag_in, bhflag_in,
     &			    nsflag_in, piflag_in, mxns_in, idum_in,
     &			    pts1_in, pts2_in, pts3_in,
     &     		    status)
cf2py intent(in) z_in
cf2py intent(in) neta_in, bwind_in, hewind_in, sigma1_in, sigma2_in
cf2py intent(in) ifflag_in, wdflag_in, bhflag_in, nsflag_in, piflag_in
cf2py intent(in) mxns_in, idum_in
cf2py intent(in) pts1_in, pts2_in, pts3_in
cf2py intent(out) status
      implicit none
      real*8 z_in, z, zpars(20)
      real*8 neta_in, bwind_in, hewind_in, sigma1_in, sigma2_in
      integer ifflag_in, wdflag_in, bhflag_in, nsflag_in, piflag_in
      integer idum_in 
      real*8 mxns_in, pts1_in, pts2_in, pts3_in
      integer status
      include 'src/const_mobse.h'
      common /SSE_init/ z, zpars

c     Input parameters are passed from MUSE, rather than being read here.

      z = z_in
      neta = neta_in
      bwind = bwind_in
      hewind = hewind_in
      sigma1 = sigma1_in
      sigma2 = sigma2_in
      ifflag = ifflag_in
      wdflag = wdflag_in
      bhflag = bhflag_in
      nsflag = nsflag_in
      mxns = mxns_in
      idum = idum_in
      pts1 = pts1_in
      pts2 = pts2_in
      pts3 = pts3_in
      
      call zcnsts(z, zpars)
      if(idum.gt.0) idum = -idum

      status = 0
      return
      end

      subroutine evolve0(kw, mass, mt, r, lum, mc, rc, menv, renv,
     &                   ospin, epoch, tm, tphys, tphysf)

c     Should work, accordig to the f2py documentation, but doesn't...

      implicit none
      integer,intent(inout) :: kw
      real*8,intent(inout) :: mass,mt,r,lum,mc,rc,menv,renv,ospin
      real*8,intent(inout) :: epoch,tm,tphys,tphysf
      real*8 z, zpars(20)
      real*8 dtp
      common /SSE_init/ z, zpars
cf2py intent(inout) mass
cf2py intent(inout) kw, mt, lum, mc, rc, menv, renv, ospin
cf2py intent(inout) epoch, tm, tphys, tphysf
cf2py intent(inout) r

      dtp = tphysf+1
      if (mass.eq.0.0) mass=mt
      call evolv1(kw, mass, mt, r, lum, mc, rc, menv, renv,
     &            ospin, epoch, tm, tphys, tphysf, dtp, z, zpars)

      return
      end
      
      subroutine evolve_star(kw, mass, mt, r, lum, mc, rc, menv, renv,
     &                  ospin, epoch, tm, tphys, tphysf,
     &              kw1, mass1, mt1, r1, lum1, mc1, rc1, menv1, renv1,
     &              ospin1, epoch1, tm1, tphys1, tphysf1)

c     Ugly, but it works!

      implicit none
      integer kw
      real*8 mass,mt,r,lum,mc,rc,menv,renv,ospin
      real*8 epoch,tm,tphys,tphysf
cf2py intent(in) kw, mass, mt, r, lum, mc, rc, menv, renv, ospin
cf2py intent(in) epoch, tm, tphys, tphysf
      integer kw1
      real*8 mass1,mt1,r1,lum1,mc1,rc1,menv1,renv1,ospin1
      real*8 epoch1,tm1,tphys1,tphysf1
cf2py intent(out) kw1, mass1, mt1, r1, lum1, mc1, rc1, menv1, renv1, ospin1
cf2py intent(out) epoch1, tm1, tphys1, tphysf1

      real*8 z, zpars(20)
      real*8 dtp
      common /SSE_init/ z, zpars

c     Copying everything is probably overkill, but not wrong.

      kw1 = kw
      mass1 = mass
      mt1 = mt
      r1 = r
      lum1 = lum
      mc1 = mc
      rc1 = rc
      menv1 = menv
      renv1 = renv
      ospin1 = ospin
      epoch1 = epoch
      tm1 = tm
      tphys1 = tphys
      tphysf1 = tphysf

      dtp = tphys1+1
      call evolv1(kw1, mass1, mt1, r1, lum1, mc1, rc1, menv1, renv1,
     &            ospin1, epoch1, tm1, tphys1, tphysf1, dtp, z, zpars)

      return
      end
      
      subroutine get_time_step(kw, mass, age, mt, tm, epoch, dt)
cf2py intent(out) dt
cf2py intent(in) kw, mass, age, mt, tm, epoch
      implicit none
      integer kw
      real*8 mass, age, mt, tm, epoch
      real*8 dt
      real*8 tscls(20), lums(10), GB(10), tn, dtm, dtr
      real*8 z, zpars(20)
      common /SSE_init/ z, zpars

!     Call star fuction to get stellar parameters
      call star(kw, mass, mt, tm, tn, tscls, lums, GB, zpars)

!     Call deltat function to get next timestep
      call deltat(kw, age-epoch, tm, tn, tscls, dtm, dtr)
      dt = min(dtr, dtm)

! fix for the very small timestep problem (where dt ~ 1.e-16 * age )
! this line mirrors the corresponding lne in evolve1.f      
      dt = MAX(dt,1.0d-07*age)
      return
      end
      
      
      subroutine get_mass_loss_wind(kw, lum, r, mt, mc, mlout)
      implicit none
      integer kw
      real*8 lum,r,mt,mc,rl
      real*8 mlout
      real*8 mlwind
      real*8 z, zpars(20)
      common /SSE_init/ z, zpars
      rl = 0.0
      mlout = mlwind(kw, lum, r, mt, mc, rl, z)
      
      return
      end


      subroutine get_gyration_radius(kw, mass, mt, r, lum, epoch, tm, 
     &                              tphys, rg)
      implicit none
      integer kw
      real*8 mass, aj, mt, tm, epoch, r, lum, tphys, mc, rc, menv, renv
      real*8 tscls(20), lums(10), GB(10), tn
      real*8 z, zpars(20)
      real*8 rg2,rg
      common /SSE_init/ z, zpars

!     Call star fuction to get stellar parameters
      call star(kw, mass, mt, tm, tn, tscls, lums, GB, zpars)
      
      aj = tphys - epoch

!     Call hrdiag fuction to get additional stellar parameters
      CALL hrdiag(mass, aj, mt, tm, tn, tscls, lums, GB, zpars,
     &               r, lum, kw, mc, rc, menv, renv, rg2)

      rg = SQRT(rg2)

      return
      end

***
      real*8 FUNCTION pisn(kw,mche,mt)
*
*     Author : N. Giacobbo
*     Date :   27th March 2017
*
*
*     Pari Instability and Pulsation Pair Instability during the 
*     supernova explosions.
*     Ref: Woosley 2016 and SEVN implementation (Spera & Mapelli 2017)
*     ----------------------------------------------------------
*     pisn = pair instability correction
*
*
      implicit none
      real*8 hefrac,kpar,val,mche,mt
      integer kw
*
* No correction
*
      pisn = 1.d0
*     
*     Pulsation Pair Instability PPISN
*     
*     use Table 2 fit from Woosley 2006
*
      if(kw.lt.7)then

         if(mche.gt.32.d0 .and. mche.lt.64.d0)then
*
*     I suppose the total he_tot is well described by the
*     the core mass
*
            hefrac = mche/mt
            kpar = 0.67d0*hefrac + 0.1d0
            if(mche.le.37.d0)then
               pisn = (kpar - 1.d0)/5.d0*mche + 
     &				(37.d0 - 32.d0*kpar) / 5.d0
            elseif(mche.gt.37.d0 .and. mche.le.60.d0)then
               pisn = kpar
            else
               pisn = - (kpar/4.d0)*mche + 16.d0*kpar
            endif
*
*     Pair-instability supernova: disintegrated
*
         elseif(mche.ge.64.d0 .and. mche.lt.135.d0)then
            pisn = 0.d0
*
*     end of PISN... again standard direct collapse
*
         else
            pisn = 1.d0
         endif


*
*     use WR table 1 fit from Woosley 2016
*
      elseif(kw.ge.7 .and. kw.le.9)then
*
*     I suppose the is composed only by he and co
*
         if(mt.gt.32.d0 .and. mt.lt.64.d0)then
            
            hefrac = 1.d0
            if(mt.le.37.d0)then
                pisn = (0.5226d0*hefrac - 0.52974d0)*(mt - 32.d0) +
     &              1.d0
            elseif(mt.gt.37.d0 .and. mt.le.56.d0)then
                val = (0.5226d0*hefrac - 0.52974d0)*5.d0 + 1.d0
                if(val.lt.0.82916d0)then
                   pisn = val
                else
                   pisn = (- 0.1381d0*hefrac + 0.1309d0)*(mt - 56.d0)
     &                  + 0.82916d0
                endif
            else
                pisn = - 0.103645d0*mt + 6.63328d0
            endif
*
*     Pair-instability supernova: disintegrated
*
         elseif(mt.ge.64.d0 .and. mt.lt.135.d0)then
            pisn = 0.d0
*
*     end of PISN... again standard direct collapse
*
         else
            pisn = 1.d0
         endif

      else
         write(*,*) 'Which are those cases?'

      endif
*
      return
**
      end

***
      SUBROUTINE star(kw,mass,mt,tm,tn,tscls,lums,GB,zpars)
*
*
*       Stellar luminosity & evolution time. 
*       ------------------------------------
*
      implicit none
*
      integer kw
*
      real*8 mass,mt,tm,tn,tscls(20),lums(10),GB(10),zpars(20)
      real*8 tgb,tbagb,mch,mcmax,mc1,mc2,mcbagb,dx,am
      real*8 lambda,tau,mtc,mass0
      parameter(mch=1.44d0)
*
      real*8 lzamsf,lzahbf,lzhef
      real*8 tbgbf,thookf,tHef,themsf,mcgbf,mcagbf,mcheif,mcgbtf
      real*8 ltmsf,lbgbf,lHeIf,lHef,lbagbf,lmcgbf
      external lzamsf,lzahbf,lzhef
      external tbgbf,thookf,tHef,themsf,mcgbf,mcagbf,mcheif,mcgbtf
      external ltmsf,lbgbf,lHeIf,lHef,lbagbf,lmcgbf
*
*       Computes the characteristic luminosities at different stages (LUMS),
*       and various timescales (TSCLS).
*       Ref: P.P. Eggleton, M.J. Fitchett & C.A. Tout (1989) Ap.J. 347, 998.
*
*       Revised 27th March 1995 by C. A. Tout
*       and 24th October 1995 to include metallicity
*       and 13th December 1996 to include naked helium stars
*
*       Revised 5th April 1997 by J. R. Hurley
*       to include Z=0.001 as well as Z=0.02, convective overshooting,
*       MS hook and more elaborate CHeB. It now also sets the Giant
*       Branch parameters relevant to the mass of the star.
*
*       ------------------------------------------------------------
*       Times: 1; BGB              2; He ignition   3; He burning
*              4; Giant t(inf1)    5; Giant t(inf2) 6; Giant t(Mx)
*              7; FAGB t(inf1)     8; FAGB t(inf2)  9; FAGB  t(Mx)
*             10; SAGB t(inf1)    11; SAGB t(inf2) 12; SAGB  t(Mx)
*             13; TP              14; t(Mcmax)     
*
*       LUMS:  1; ZAMS             2; End MS        3; BGB
*              4; He ignition      5; He burning    6; L(Mx)
*              7; BAGB             8; TP
*
*       GB:    1; effective A(H)   2; A(H,He)       3; B
*              4; D                5; p             6; q
*              7; Mx               8; A(He)         9; Mc,BGB
*
*       ------------------------------------------------------------
*
*
***
*
      mass0 = mass
      if(mass0.gt.150.d0)then
         WRITE(99,*)' MASS EXCEEDED in star.f',mass0
         mass = 150.d0
      endif
*
***
      if(kw.ge.7.and.kw.le.9) goto 90
      if(kw.ge.10) goto 95
*
* MS and BGB times
*
      tscls(1) = tbgbf(mass)
      tm = MAX(zpars(8),thookf(mass))*tscls(1)
*
* Zero- and terminal age main sequence luminosity
*
      lums(1) = lzamsf(mass)
      lums(2) = ltmsf(mass)
*
* Set the GB parameters
*
      GB(1) = MAX(-4.8d0,MIN(-5.7d0+0.8d0*mass,-4.1d0+0.14d0*mass))
      GB(1) = 10.d0**GB(1)
      GB(2) = 1.27d-05
      GB(8) = 8.0d-05
      GB(3) = MAX(3.0d+04,500.d0 + 1.75d+04*mass**0.6d0)
      if(mass.le.2.0)then
         GB(4) = zpars(6)
         GB(5) = 6.d0
         GB(6) = 3.d0
      elseif(mass.lt.2.5)then
         dx = zpars(6) - (0.975d0*zpars(6) - 0.18d0*2.5d0)
         GB(4) = zpars(6) - dx*(mass - 2.d0)/(0.5d0)
         GB(5) = 6.d0 - (mass - 2.d0)/(0.5d0)
         GB(6) = 3.d0 - (mass - 2.d0)/(0.5d0)
      else
         GB(4) = MAX(-1.d0,0.5d0*zpars(6) - 0.06d0*mass)
         GB(4) = MAX(GB(4),0.975d0*zpars(6) - 0.18d0*mass)
         GB(5) = 5.d0
         GB(6) = 2.d0
      endif
      GB(4) = 10.d0**GB(4)
      GB(7) = (GB(3)/GB(4))**(1.d0/(GB(5)-GB(6)))
*
* Change in slope of giant L-Mc relation.
      lums(6) = GB(4)*GB(7)**GB(5)
*
* HeI ignition luminosity
      lums(4) = lHeIf(mass,zpars(2)) 
      lums(7) = lbagbf(mass,zpars(2))
*
      if(mass.lt.0.1d0.and.kw.le.1)then
         tscls(2) = 1.1d0*tscls(1)
         tscls(3) = 0.1d0*tscls(1)
         lums(3) = lbgbf(mass) 
         goto 96
      endif
*
      if(mass.le.zpars(3))then
* Base of the giant branch luminosity
         lums(3) = lbgbf(mass) 
* Set GB timescales 
         tscls(4) = tscls(1) + (1.d0/((GB(5)-1.d0)*GB(1)*GB(4)))*
     &              ((GB(4)/lums(3))**((GB(5)-1.d0)/GB(5)))
         tscls(6) = tscls(4) - (tscls(4) - tscls(1))*((lums(3)/lums(6))
     &              **((GB(5)-1.d0)/GB(5)))
         tscls(5) = tscls(6) + (1.d0/((GB(6)-1.d0)*GB(1)*GB(3)))*
     &              ((GB(3)/lums(6))**((GB(6)-1.d0)/GB(6)))
* Set Helium ignition time
         if(lums(4).le.lums(6))then
            tscls(2) = tscls(4) - (1.d0/((GB(5)-1.d0)*GB(1)*GB(4)))*
     &                      ((GB(4)/lums(4))**((GB(5)-1.d0)/GB(5)))
         else
            tscls(2) = tscls(5) - (1.d0/((GB(6)-1.d0)*GB(1)*GB(3)))*
     &                      ((GB(3)/lums(4))**((GB(6)-1.d0)/GB(6)))
         endif
         tgb = tscls(2) - tscls(1)
         if(mass.le.zpars(2))then
            mc1 = mcgbf(lums(4),GB,lums(6))
            mc2 = mcagbf(mass)
            lums(5) = lzahbf(mass,mc1,zpars(2))
            tscls(3) = tHef(mass,mc1,zpars(2))
         else
            lums(5) = lHef(mass)*lums(4)
            tscls(3) = tHef(mass,1.d0,zpars(2))*tscls(1)
         endif
      else
* Note that for M>zpars(3) there is no GB as the star goes from
* HG -> CHeB -> AGB. So in effect tscls(1) refers to the time of
* Helium ignition and not the BGB.
         tscls(2) = tscls(1)
         tscls(3) = tHef(mass,1.d0,zpars(2))*tscls(1)
* This now represents the luminosity at the end of CHeB, ie. BAGB
         lums(5) = lums(7)
* We set lums(3) to be the luminosity at the end of the HG
         lums(3) = lums(4)
      endif
*
* Set the core mass at the BGB.
*
      if(mass.le.zpars(2))then
         GB(9) = mcgbf(lums(3),GB,lums(6))
      elseif(mass.le.zpars(3))then
         GB(9) = mcheif(mass,zpars(2),zpars(9))
      else
         GB(9) = mcheif(mass,zpars(2),zpars(10))
      endif
*
* FAGB time parameters
*
      tbagb = tscls(2) + tscls(3)
      tscls(7) = tbagb + (1.d0/((GB(5)-1.d0)*GB(8)*GB(4)))*
     &               ((GB(4)/lums(7))**((GB(5)-1.d0)/GB(5)))
      tscls(9) = tscls(7) - (tscls(7) - tbagb)*((lums(7)/lums(6))
     &                                    **((GB(5)-1.d0)/GB(5)))
      tscls(8) = tscls(9) + (1.d0/((GB(6)-1.d0)*GB(8)*GB(3)))*
     &               ((GB(3)/lums(6))**((GB(6)-1.d0)/GB(6)))
*
* Now to find Ltp and ttp using Mc,He,tp
*
      mcbagb = mcagbf(mass)
      mc1 = mcbagb
      if(mc1.ge.0.8d0.and.mc1.lt.2.25d0)then
* The star undergoes dredge-up at Ltp causing a decrease in Mc,He
         mc1 = 0.44d0*mc1 + 0.448d0
      endif
      lums(8) = lmcgbf(mc1,GB)
      if(mc1.le.GB(7))then
         tscls(13) = tscls(7) - (1.d0/((GB(5)-1.d0)*GB(8)*GB(4)))*
     &                   (mc1**(1.d0-GB(5)))
      else
         tscls(13) = tscls(8) - (1.d0/((GB(6)-1.d0)*GB(8)*GB(3)))*
     &                   (mc1**(1.d0-GB(6)))
      endif
*
* SAGB time parameters
*
      if(mc1.le.GB(7))then
         tscls(10) = tscls(13) + (1.d0/((GB(5)-1.d0)*GB(2)*GB(4)))*
     &               ((GB(4)/lums(8))**((GB(5)-1.d0)/GB(5)))
         tscls(12) = tscls(10) - (tscls(10) - tscls(13))*
     &               ((lums(8)/lums(6))**((GB(5)-1.d0)/GB(5)))
         tscls(11) = tscls(12) + (1.d0/((GB(6)-1.d0)*GB(2)*GB(3)))*
     &               ((GB(3)/lums(6))**((GB(6)-1.d0)/GB(6)))
      else
         tscls(10) = tscls(7)
         tscls(12) = tscls(9)
         tscls(11) = tscls(13) + (1.d0/((GB(6)-1.d0)*GB(2)*GB(3)))*
     &               ((GB(3)/lums(8))**((GB(6)-1.d0)/GB(6)))
      endif
*
* Get an idea of when Mc,C = Mc,C,max on the AGB
      tau = tscls(2) + tscls(3)
      mc2 = mcgbtf(tau,GB(8),GB,tscls(7),tscls(8),tscls(9))
      mcmax = MAX(MAX(mch,0.773d0*mcbagb - 0.35d0),1.05d0*mc2)
*
      if(mcmax.le.mc1)then
         if(mcmax.le.GB(7))then
            tscls(14) = tscls(7) - (1.d0/((GB(5)-1.d0)*GB(8)*GB(4)))*
     &                      (mcmax**(1.d0-GB(5)))
         else
            tscls(14) = tscls(8) - (1.d0/((GB(6)-1.d0)*GB(8)*GB(3)))*
     &                      (mcmax**(1.d0-GB(6)))
         endif
      else
* Star is on SAGB and we need to increase mcmax if any 3rd
* dredge-up has occurred.
         lambda = MIN(0.9d0,0.3d0+0.001d0*mass**5)
         mcmax = (mcmax - lambda*mc1)/(1.d0 - lambda)
         if(mcmax.le.GB(7))then
            tscls(14) = tscls(10) - (1.d0/((GB(5)-1.d0)*GB(2)*GB(4)))*
     &                      (mcmax**(1.d0-GB(5)))
         else
            tscls(14) = tscls(11) - (1.d0/((GB(6)-1.d0)*GB(2)*GB(3)))*
     &                      (mcmax**(1.d0-GB(6)))
         endif
      endif
      tscls(14) = MAX(tbagb,tscls(14))
* MM: changed from 100 to 1000
      if(mass.ge.1000.d0)then
         tn = tscls(2)
         goto 100
      endif
*
* Calculate the nuclear timescale - the time of exhausting
* nuclear fuel without further mass loss.
* This means we want to find when Mc = Mt which defines Tn and will
* be used in determining the timestep required. Note that after some 
* stars reach Mc = Mt there will be a Naked Helium Star lifetime
* which is also a nuclear burning period but is not included in Tn.
*
      if(ABS(mt-mcbagb).lt.1.0d-14.and.kw.lt.5)then
         tn = tbagb
      else
* Note that the only occurence of Mc being double-valued is for stars
* that have a dredge-up. If Mt = Mc where Mc could be the value taken
* from CHeB or from the AGB we need to check the current stellar type.
         if(mt.gt.mcbagb.or.(mt.ge.mc1.and.kw.gt.4))then
            if(kw.eq.6)then
               lambda = MIN(0.9d0,0.3d0+0.001d0*mass**5)
               mc1 = (mt - lambda*mc1)/(1.d0 - lambda)
            else
               mc1 = mt
            endif
            if(mc1.le.GB(7))then
               tn = tscls(10) - (1.d0/((GB(5)-1.d0)*GB(2)*GB(4)))*
     &                         (mc1**(1.d0-GB(5)))
            else
               tn = tscls(11) - (1.d0/((GB(6)-1.d0)*GB(2)*GB(3)))*
     &                         (mc1**(1.d0-GB(6)))
            endif
         else
            if(mass.gt.zpars(3))then
               mc1 = mcheif(mass,zpars(2),zpars(10))
               if(mt.le.mc1)then
                  tn = tscls(2)
               else
                  tn = tscls(2) + tscls(3)*((mt - mc1)/(mcbagb - mc1))
               endif
            elseif(mass.le.zpars(2))then
               mc1 = mcgbf(lums(3),GB,lums(6))
               mc2 = mcgbf(lums(4),GB,lums(6))
               if(mt.le.mc1)then
                  tn = tscls(1)
               elseif(mt.le.mc2)then
                  if(mt.le.GB(7))then
                     tn = tscls(4) - (1.d0/((GB(5)-1.d0)*GB(1)*GB(4)))*
     &                               (mt**(1.d0-GB(5)))
                  else
                     tn = tscls(5) - (1.d0/((GB(6)-1.d0)*GB(1)*GB(3)))*
     &                               (mt**(1.d0-GB(6)))
                  endif
               else
                  tn = tscls(2) + tscls(3)*((mt - mc2)/(mcbagb - mc2))
               endif
            else
               mc1 = mcheif(mass,zpars(2),zpars(9))
               mc2 = mcheif(mass,zpars(2),zpars(10))
               if(mt.le.mc1)then
                  tn = tscls(1)
               elseif(mt.le.mc2)then
                  tn = tscls(1) + tgb*((mt - mc1)/(mc2 - mc1))
               else
                  tn = tscls(2) + tscls(3)*((mt - mc2)/(mcbagb - mc2))
               endif
            endif
         endif
      endif
      tn = MIN(tn,tscls(14))
*
      goto 100
*
 90   continue
*
* Calculate Helium star Main Sequence lifetime.
*
      tm = themsf(mass)
      tscls(1) = tm
*
* Zero- and terminal age Helium star main sequence luminosity
*
      lums(1) = lzhef(mass)
      am = MAX(0.d0,0.85d0-0.08d0*mass)
      lums(2) = lums(1)*(1.d0+0.45d0+am)
*
* Set the Helium star GB parameters
*
      GB(8) = 8.0d-05
      GB(3) = 4.1d+04
      GB(4) = 5.5d+04/(1.d0+0.4d0*mass**4)
      GB(5) = 5.d0
      GB(6) = 3.d0
      GB(7) = (GB(3)/GB(4))**(1.d0/(GB(5)-GB(6)))
* Change in slope of giant L-Mc relation.
      lums(6) = GB(4)*GB(7)**GB(5)
*
*** Set Helium star GB timescales 
*
      mc1 = mcgbf(lums(2),GB,lums(6))
      tscls(4) = tm + (1.d0/((GB(5)-1.d0)*GB(8)*GB(4)))*
     &                                          mc1**(1.d0-GB(5))
      tscls(6) = tscls(4) - (tscls(4) - tm)*((GB(7)/mc1)
     &                                     **(1.d0-GB(5)))
      tscls(5) = tscls(6) + (1.d0/((GB(6)-1.d0)*GB(8)*GB(3)))*
     &                                       GB(7)**(1.d0-GB(6))
*
* Get an idea of when Mc = MIN(Mt,Mc,C,max) on the GB
      mtc = MIN(mt,1.45d0*mt-0.31d0)
      if(mtc.le.0.d0) mtc = mt
      mcmax = MIN(mtc,MAX(mch,0.773d0*mass-0.35d0))
      if(mcmax.le.GB(7))then
         tscls(14) = tscls(4) - (1.d0/((GB(5)-1.d0)*GB(8)*GB(4)))*
     &                   (mcmax**(1.d0-GB(5)))
      else
         tscls(14) = tscls(5) - (1.d0/((GB(6)-1.d0)*GB(8)*GB(3)))*
     &                   (mcmax**(1.d0-GB(6)))
      endif
      tscls(14) = MAX(tscls(14),tm)
      tn = tscls(14)
*
      goto 100
*
 95   continue
      tm = 1.0d+10
      tscls(1) = tm
 96   continue
      tn = 1.0d+10
*
 100  continue
      mass = mass0
*
      return
      end
***

***
      SUBROUTINE evolv1(kw,mass,mt,r,lum,mc,rc,menv,renv,ospin,
     &                  epoch,tm,tphys,tphysf,dtp,z,zpars)
c-------------------------------------------------------------c
c
c     Evolves a single star.
c     Mass loss is an option.
c     The timestep is not constant but determined by certain criteria.
c     Plots the HRD and variables as a function of time.
c
c     Written by Jarrod Hurley 26/08/97 at the Institute of
c     Astronomy, Cambridge.
c
c-------------------------------------------------------------c
c
c     STELLAR TYPES - KW
c
c        0 - deeply or fully convective low mass MS star
c        1 - Main Sequence star
c        2 - Hertzsprung Gap
c        3 - First Giant Branch
c        4 - Core Helium Burning
c        5 - First Asymptotic Giant Branch
c        6 - Second Asymptotic Giant Branch
c        7 - Main Sequence Naked Helium star
c        8 - Hertzsprung Gap Naked Helium star
c        9 - Giant Branch Naked Helium star
c       10 - Helium White Dwarf
c       11 - Carbon/Oxygen White Dwarf
c       12 - Oxygen/Neon White Dwarf
c       13 - Neutron Star
c       14 - Black Hole
c       15 - Massless Supernova
c
c-------------------------------------------------------------c
      implicit none
*
      integer kw,it,ip,jp,j,kwold,rflag
      integer nv
      parameter(nv=50000)
*
      real*8 mass,z,aj
      real*8 epoch,tphys,tphys2,tmold,tbgold
      real*8 mt,tm,tn,tphysf,dtp,tsave
      real*8 tscls(20),lums(10),GB(10),zpars(20)
      real*8 r,lum,mc,teff,rc,menv,renv,vs(3)
      real*8 ospin,jspin,djt,djmb,k2,k3
      parameter(k3=0.21d0)
      real*8 m0,r1,lum1,mc1,rc1,menv1,renv1,k21
      real*8 dt,dtm,dtr,dr,dtdr,dms,dml,mt2,rl
      real*8 tol,tiny
      parameter(tol=1.0d-10,tiny=1.0d-14)
      real*8 ajhold,rm0,eps,alpha2
      parameter(eps=1.0d-06,alpha2=0.09d0)
      real*8 mlwind,vrotf
      external mlwind,vrotf
      logical iplot,isave
      REAL*8 neta,bwind,hewind,mxns
      COMMON /VALUE1/ neta,bwind,hewind,mxns
      REAL*8 pts1,pts2,pts3
      COMMON /POINTS/ pts1,pts2,pts3
      REAL scm(50000,14),spp(20,3)
      COMMON /SINGLE/ scm,spp
*
      dtm = 0.d0
      r = 0.d0
      lum = 0.d0
      mc = 0.d0
      mc1 = 0.d0
      rc = 0.d0
      rl = 0.d0
      if(ospin.le.0.d0)then
         ospin = 1.0d-10
         jspin = 1.0d-10
      endif
      k2 = 0.15d0
      rflag = 0
*
* Setup variables which control the output (if it is required).
*
      ip = 0
      jp = 0
      tsave = tphys
      isave = .true.
      iplot = .false.
      if(dtp.le.0.d0)then
         iplot = .true.
         isave = .false.
         tsave = tphysf
      elseif(dtp.gt.tphysf)then
         isave = .false.
         tsave = tphysf
      endif
* 
      do 10 , j = 1,nv
*
         if(neta.gt.tiny.and.j.gt.1)then
*
* Calculate mass loss from the previous timestep.
*
            dt = 1.0d+06*dtm
            dms = mlwind(kw,lum,r,mt,mc,rl,z)*dt
            if(kw.lt.10)then
               dml = mt - mc
               if(dml.lt.dms)then
                  dtm = (dml/dms)*dtm
                  dms = dml
               endif
            endif
         else
            dms = 0.d0
         endif
*
* Limit to 1% mass loss.
*
         if(dms.gt.0.01d0*mt)then
            dtm = 0.01d0*mt*dtm/dms
            dms = 0.01d0*mt
         endif
*
* Calculate the rate of angular momentum loss due to magnetic braking 
* and/or mass loss.
*
         if(j.gt.1)then
            djt = (2.d0/3.d0)*(dms/(1.0d+06*dtm))*r*r*ospin
            if(mt.gt.0.35d0.and.kw.lt.10)then
               djmb = 5.83d-16*menv*(r*ospin)**3/mt
               djt = djt + djmb
            endif
         endif
*
* Update mass and time and reset epoch for a MS (and possibly a HG) star.
*
         if(dms.gt.0.d0)then
            mt = mt - dms
            if(kw.le.2.or.kw.eq.7)then
               m0 = mass
               mc1 = mc
               mass = mt
               tmold = tm
               tbgold = tscls(1)
               CALL star(kw,mass,mt,tm,tn,tscls,lums,GB,zpars)
               if(kw.eq.2)then
                  if(GB(9).lt.mc1.or.m0.gt.zpars(3))then
                     mass = m0
                  else
                     epoch = tm + (tscls(1) - tm)*(ajhold-tmold)/
     &                            (tbgold - tmold)
                     epoch = tphys - epoch
                  endif
               else
                  epoch = tphys - ajhold*tm/tmold
               endif
            endif
         endif
         tphys2 = tphys
         tphys = tphys + dtm
*
* Find the landmark luminosities and timescales as well as setting
* the GB parameters.
*
         aj = tphys - epoch
         CALL star(kw,mass,mt,tm,tn,tscls,lums,GB,zpars)
*
* Find the current radius, luminosity, core mass and stellar type
* given the initial mass, current mass, metallicity and age
*
         kwold = kw
         CALL hrdiag(mass,aj,mt,tm,tn,tscls,lums,GB,zpars,
     &               r,lum,kw,mc,rc,menv,renv,k2)
*
* If mass loss has occurred and no type change then check that we
* have indeed limited the radius change to 10%.
*
         if(kw.eq.kwold.and.dms.gt.0.d0.and.rflag.ne.0)then
            mt2 = mt + dms
            dml = dms/dtm
            it = 0
 20         dr = r - rm0
            if(ABS(dr).gt.0.1d0*rm0)then
               it = it + 1
               if(it.eq.20.and.kw.eq.4) goto 30
               if(it.gt.30)then
                  WRITE(99,*)' DANGER1! ',it,kw,mass,dr,rm0
                  WRITE(*,*)' STOP: EVOLV1 FATAL ERROR '
                  CALL exit(0)
                  STOP 
               endif
               dtdr = dtm/ABS(dr)
               dtm = alpha2*MAX(rm0,r)*dtdr
               if(it.ge.20) dtm = 0.5d0*dtm
               if(dtm.lt.1.0d-07*aj) goto 30
               dms = dtm*dml
               mt = mt2 - dms
               if(kw.le.2.or.kw.eq.7)then
                  mass = mt
                  CALL star(kw,mass,mt,tm,tn,tscls,lums,GB,zpars)
                  if(kw.eq.2)then
                     if(GB(9).lt.mc1.or.m0.gt.zpars(3))then
                        mass = m0
                     else
                        epoch = tm + (tscls(1) - tm)*(ajhold-tmold)/
     &                               (tbgold - tmold)
                        epoch = tphys2 - epoch
                     endif
                  else
                     epoch = tphys2 - ajhold*tm/tmold
                  endif
               endif
               tphys = tphys2 + dtm
               aj = tphys - epoch
               mc = mc1
               CALL star(kw,mass,mt,tm,tn,tscls,lums,GB,zpars)
               CALL hrdiag(mass,aj,mt,tm,tn,tscls,lums,GB,zpars,
     &                     r,lum,kw,mc,rc,menv,renv,k2)
               goto 20
            endif
 30         continue
         endif
*
* Initialize or adjust the spin of the star.
*
         if(j.eq.1)then
            if(tphys.lt.tiny.and.ospin.lt.0.001d0)then
               ospin = 45.35d0*vrotf(mt)/r
            endif
            jspin = ospin*(k2*r*r*(mt-mc)+k3*rc*rc*mc)
         else
            jspin = MAX(1.0d-10,jspin - djt*1.0d+06*dtm)
            ospin = jspin/(k2*r*r*(mt-mc)+k3*rc*rc*mc)
         endif
*
* Test for changes in evolution type.
*
         if(j.eq.1.or.kw.ne.kwold)then
*
* Force new NS or BH to have a one second period. 
* 
            if(kw.eq.13.or.kw.eq.14)then
               ospin = 2.0d+08
               jspin = k3*rc*rc*mc*ospin
               CALL kick(kw,mass,mt,0.d0,0.d0,-1.d0,0.d0,vs)
            endif
            jp = jp + 1
            spp(jp,1) = tphys
            spp(jp,2) = float(kw)
            if(kw.eq.15)then
               spp(jp,3) = mass 
               goto 90
            else
               spp(jp,3) = mt
            endif
         endif
*
* Record values for plotting and reset epoch.
*
         epoch = tphys - aj
         if((isave.and.tphys.ge.tsave).or.iplot)then
            ip = ip + 1
            scm(ip,1) = tphys
            scm(ip,2) = float(kw)
            scm(ip,3) = mass
            scm(ip,4) = mt
            scm(ip,5) = log10(lum)
            scm(ip,6) = log10(r)
            teff = 1000.d0*((1130.d0*lum/(r**2.d0))**(1.d0/4.d0))
            scm(ip,7) = log10(teff)
            scm(ip,8) = mc
            scm(ip,9) = rc
            scm(ip,10) = menv
            scm(ip,11) = renv
            scm(ip,12) = epoch
            scm(ip,13) = ospin
            if(isave) tsave = tsave + dtp
            if(tphysf.lt.tiny)then
               ip = ip + 1
               do 35 , it = 1,13
                  scm(ip,it) = scm(ip-1,it)
 35            continue
            endif
         endif
*
         if(tphys.ge.tphysf)then
            jp = jp + 1
            spp(jp,1) = tphys
            spp(jp,2) = float(kw)
            spp(jp,3) = mt
            goto 90
         endif
*
* Record radius and current age.
*
         rm0 = r
         ajhold = aj
         if(kw.ne.kwold) kwold = kw
         CALL deltat(kw,aj,tm,tn,tscls,dtm,dtr)
*
* Check for type change.
*
         it = 0
         m0 = mass
         if((dtr-dtm).le.tol.and.kw.le.9)then
*
* Check final radius for too large a jump.
*
            aj = MAX(aj,aj*(1.d0-eps)+dtr)
            mc1 = mc 
            CALL hrdiag(mass,aj,mt,tm,tn,tscls,lums,GB,zpars,
     &                  r1,lum1,kw,mc1,rc1,menv1,renv1,k21)
            dr = r1 - rm0
            if(ABS(dr).gt.0.1d0*rm0)then
               dtm = dtr - ajhold*eps
               dtdr = dtm/ABS(dr)
               dtm = alpha2*MAX(r1,rm0)*dtdr
               goto 40
            else
               dtm = dtr
               goto 50
            endif
         endif
*
* Limit to a 10% increase in radius assuming no further mass loss
* and thus that the pertubation functions due to small envelope mass
* will not change the radius.
*
 40      aj = ajhold + dtm
         mc1 = mc 
         CALL hrdiag(mass,aj,mt,tm,tn,tscls,lums,GB,zpars,
     &               r1,lum1,kw,mc1,rc1,menv1,renv1,k21)
         dr = r1 - rm0
         it = it + 1
         if(it.eq.20.and.kw.eq.4) goto 50
         if(it.gt.30)then
            WRITE(99,*)' DANGER2! ',it,kw,mass,dr,rm0
            WRITE(*,*)' STOP: EVOLV1 FATAL ERROR '
            CALL exit(0)
            STOP 
         endif
         if(ABS(dr).gt.0.1d0*rm0)then
            dtdr = dtm/ABS(dr)
            dtm = alpha2*MAX(rm0,r1)*dtdr
            if(it.ge.20) dtm = 0.5d0*dtm
            goto 40
         endif
*
 50      continue
*
* Ensure that change of type has not occurred during radius check. 
* This is rare but may occur for HG stars of ZAMS mass > 50 Msun. 
*
         if(kw.ne.kwold)then
            kw = kwold
            mass = m0
            CALL star(kw,mass,mt,tm,tn,tscls,lums,GB,zpars)
         endif
*
* Choose minimum of time-scale and remaining interval (> 100 yrs).
*
         dtm = MAX(dtm,1.0d-07*aj)
         dtm = MIN(dtm,tsave-tphys)
*
 10   continue
*
 90   continue
*
      tphysf = tphys
      scm(ip+1,1) = -1.0
      spp(jp+1,1) = -1.0
      if(ip.ge.nv)then
         WRITE(99,*)' EVOLV1 ARRAY ERROR ',mass
         WRITE(*,*)' STOP: EVOLV1 ARRAY ERROR '
         CALL exit(0)
         STOP
      endif
*
      RETURN
      END
***

***
      SUBROUTINE evolv3(kstar,mass0,mass,rad,lumin,massc,radc,
     &                  menv,renv,ospin,epoch,tms,
     &                  tphys,tphysf,dtp,z,zpars,tb,ecc)
      implicit none
***
*
*           B I N A R Y
*           ***********
*
*       Roche lobe overflow.
*       --------------------
*
*       Developed by Jarrod Hurley, IOA, Cambridge.
*       .........................................................
*
*       Advice by Christopher Tout, Onno Pols & Sverre Aarseth.
*       ++++++++++++++++++++++++++++++++++++++++++++++++++
*
* Adapted from Aarseth's code 21st September 1996.
* Fully revised on 27th November 1996 to remove vestiges of N-body code and
* incorporate corrections.
* Fully revised on 1st April 1998 to include new stellar evolution formulae
* and associated binary evolution changes.
* Fully revised on 4th July 1998 to include eccentricity, tidal 
* circularization, wind accretion, velocity kicks for supernovae and all
* associated orbital momentum changes.
* Revised on 31st October 2000 to upgrade restrictions imposed on the 
* timestep owing to magnetic braking and orbital angular momentum changes. 
* Revised on 15th May 2016 to include a new treatment for HG stars during the CE phase and
* velocity kick for supernova (NSs and BHs).
*
***
*
* See Tout et al., 1997, MNRAS, 291, 732 for a description of many of the
* processes in this code as well as the relevant references mentioned
* within the code. 
*
* Reference for the stellar evolution formulae is Hurley, Pols & Tout, 
* 2000, MNRAS, 315, 543 (SSE paper).  
* Reference for the binary evolution algorithm is Hurley, Tout & Pols, 
* 2002, MNRAS, 329, 897 (BSE paper). 
*
* Reference for updates Giacobbo et al. 2018 (MOBSE paper)
*
***
*
* March 2001 *
* Changes since version 3, i.e. since production of Paper3:  
*
* 1) The Eddington limit flag (on/off) has been replaced by an 
*    Eddington limit multiplicative factor (eddfac). So if you 
*    want to neglect the Eddington limit you would set eddfac 
*    to a large value. 
*
* 2) To determine whether material transferred during RLOF forms 
*    an accretion disk around the secondary or hits the secondary 
*    in a direct stream we calculate a minimum radial distance, rmin, 
*    of the mass stream from the secondary. This is taken from eq.(1) 
*    of Ulrich & Burger (1976, ApJ, 206, 509) which they fitted to 
*    the calculations of Lubow & Shu (1974, ApJ, 198, 383).
*    If rmin is less than the radius of the secondary then an 
*    accretion disk is not formed. 
*    Note that the formula for rmin given by Ulrich & Burger is valid 
*    for all q whereas that given by Nelemans et al. (2001, A&A, 
*    submitted) in their eq.(6) is only valid for q < 1 where 
*    they define q = Mdonor/Maccretor, i.e. DD systems. 
*
* 3) The changes to orbital and spin angular momentum owing to 
*    RLOF mass transfer have been improved, and an new input option 
*    now exists. 
*    When mass is lost from the system during RLOF there are now 
*    three choices as to how the orbital angular momentum is 
*    affected: a) the lost material carries with it a fraction 
*    gamma of the orbital angular momentum, i.e. 
*    dJorb = gamma*dm*a^2*omega_orb; b) the material carries with it 
*    the specific angular momentum of the primary, i.e.
*    dJorb = dm*a_1^2*omega_orb; or c) assume the material is lost 
*    from the system as if a wind from the secondary, i.e.
*    dJorb = dm*a_2^2*omega_orb. 
*    The parameter gamma is an input option. 
*    Choice c) is used if the mass transfer is super-Eddington 
*    or the system is experiencing novae eruptions. 
*    In all other cases choice a) is used if gamma > 0.0, b) if 
*    gamma = -1.0 and c) is used if gamma = -2.0. 
*    The primary spin angular momentum is reduced by an amount 
*    dm1*r_1^2*omega_1 when an amount of mass dm1 is transferred 
*    from the primary. 
*    If the secondary accretes through a disk then its spin 
*    angular momentum is altered by assuming that the material 
*    falls onto the star from the inner edge of a Keplerian 
*    disk and that the system is in a steady state, i.e. 
*    an amount dm2*SQRT(G*m_2*r_2). 
*    If there is no accretion disk then we calculate the angular 
*    momentum of the transferred material by using the radius at 
*    at which the disk would have formed (rdisk = 1.7*rmin, see 
*    Ulrich & Burger 1976) if allowed, i.e. the angular momentum 
*    of the inner Lagrangian point, and add this directly to 
*    the secondary, i.e. an amount dm2*SQRT(G*m_2*rdisk). 
*    Total angular momentum is conserved in this model. 
*
* 4) Now using q_crit = 3.0 for MS-MS Roche systems (previously we 
*    had nothing). This corresponds roughly to R proportional to M^5 
*    which should be true for the majority of the MS (varies from 
*    (M^17 -> M^2). If q > q_crit then contact occurs. 
*    For CHeB primaries we also take q_crit = 3.0 and allow 
*    common-envelope to occur if this is exceeded. 
*
* 5) The value of lambda used in calculations of the envelope binding 
*    energy for giants in common-envelope is now variable (see function 
*    in zfuncs). The lambda function has been fitted by Onno to detailed 
*    models ... he will write about this soon!
*
* 6) Note that eq.42 in the paper is missing a SQRT aexit example fortranround the
*    MR^2/a^5 part. This needs to be corrected in any code update
*    paper with a thanks to Jeremy Sepinsky (student at NorthWestern).
*    It is ok in the code.
*
* March 2003 *
* New input options added:  
*
*    ifflag - for the mass of a WD you can choose to use the mass that 
*             results from the evolution algorithm (basically a competition
*             between core-mass growth and envelope mass-loss) or use the IFMR 
*             proposed by Han, Podsiadlowski & Eggleton, 1995, MNRAS, 272, 800
*             [>0 activates HPE IFMR]. 
*
*    wdflag - for the cooling of WDs you can choose to use either the standard 
*             Mestel cooling law (see SSE paper) or a modified-Mestel law that 
*             is better matched to detailed models (provided by Brad Hansen 
*             ... see Hurley & Shara, 2003, ApJ, May 20, in press) 
*             [>0 activates modified-Mestel]. 
*
*    bhflag - choose whether or not black holes should get velocity kicks 
*             at formation 
*             [0= no kick; >0 kick]. 
*
*    nsflag - for the mass of neutron stars and black holes you can use either 
*             the SSE prescription or the prescription presented by 
*             Belczynski et al. 2002, ApJ, 572, 407 who found that SSE was 
*             underestimating the masses of these stars. In either case you also 
*             need to set the maximum NS mass (mxns) for the prescription  
*             [0= SSE, mxns=1.8; >0 Belczynski, mxns=3.0].
*
* Sept 2004 *
* Input options added/changed:
*
*    ceflag - set to 3 this uses de Kool (or Podsiadlowski) CE prescription, 
*             other options, such as Yungelson, could be added as well. 
*
*    hewind - factor to control the amount of He star mass-loss, i.e.
*             1.0e-13*hewind*L^(2/3) gives He star mass-loss.
*
* NOTE: some versions may have contained a bug in the calculation of the 
*       f factor for convective tides. The incorrect line was: 
*             f = MIN(1.d0,(ttid/(2.d0*tc)**2))
*
* May 2017 *
* Some upgrades:
*           1) New treatment for the HG stars during the CE phase.
*              During the HG phase, stars do not present a steep density
*              gradient between the core and the envelope and for this reason
*              their response to the CE phase should be similar to that of MS
*              stars (see Ivanova & Taam 2004). In BSE, when a MS star enters
*              a CE phase as donor it merges with the accretor, while HG donors
*              are allowed to survive the CE phase. In MOBSE we imposed that
*              even HG donors merge with their companions if they enter a CE phase.
*           2) new to compute the velocity kick for both neutron stars and
*              black holes.
*           3) nsflag   - new prescriptions for supernova explosions (SN).
*           4) pisnflag - it allows to activate the PISN (Pair Instability)
*                         and PPISN (Pulsation PISN).
*       ++++++++++++++++++++++++++++++++++++++++++++++++++
***
*
      INTEGER loop,iter,intpol,k,ip,jp,j1,j2
      PARAMETER(loop=20000)
      INTEGER kstar(2),kw,kst,kw1,kw2,kmin,kmax,helper(2)
      INTEGER ktype(0:14,0:14)
      COMMON /TYPES/ ktype
      INTEGER ceflag,tflag,ifflag,nsflag,wdflag,piflag
      COMMON /FLAGS/ ceflag,tflag,ifflag,nsflag,wdflag,piflag
*
      REAL*8 km,km0,tphys,tphys0,dtm0,tphys00
      REAL*8 tphysf,dtp,tsave
      REAL*8 aj(2),aj0(2),epoch(2),tms(2),tbgb(2),tkh(2),dtmi(2)
      REAL*8 mass0(2),mass(2),massc(2),menv(2),mass00(2),mcxx(2)
      REAL*8 rad(2),rol(2),rol0(2),rdot(2),radc(2),renv(2),radx(2)
      REAL*8 lumin(2),k2str(2),q(2),dms(2),dmr(2),dmt(2)
      REAL*8 dml,vorb2,vwind2,omv2,ivsqm,lacc,vs(3)
      REAL*8 sep,dr,tb,dme,tdyn,taum,dm1,dm2,dmchk,qc,dt,pd,rlperi
      REAL*8 m1ce,m2ce,mch,tmsnew,dm22,mew
      PARAMETER(mch=1.44d0)
      REAL*8 yeardy,aursun
      PARAMETER(yeardy=365.24d0,aursun=214.95d0)
      REAL*8 acc1,tiny
      PARAMETER(acc1=3.920659d+08,tiny=1.0d-14)
      REAL*8 ecc,ecc1,tc,tcirc,ttid,ecc2,omecc2,sqome2,sqome3,sqome5
      REAL*8 f1,f2,f3,f4,f5,f,raa2,raa6,eqspin,rg2,tcqr
      REAL*8 k3,mr23yr,twopi
      PARAMETER(k3=0.21d0,mr23yr=0.4311d0)
      REAL*8 jspin(2),ospin(2),jorb,oorb,jspbru,ospbru
      REAL*8 delet,delet1,dspint(2),djspint(2),djtx(2)
      REAL*8 dtj,djorb,djgr,djmb,djt,djtt,rmin,rdisk
      REAL*8 neta,bwind,hewind,mxns
      COMMON /VALUE1/ neta,bwind,hewind,mxns
      REAL*8 beta,xi,acc2,epsnov,eddfac,gamma
      COMMON /VALUE5/ beta,xi,acc2,epsnov,eddfac,gamma
*
      REAL*8 z,tm,tn,m0,mt,rm,lum,mc,rc,me,re,k2,age,dtm,dtr
      REAL*8 tscls(20),lums(10),GB(10),zpars(20)
      REAL*8 zero,ngtv,ngtv2,mt2,rrl1,rrl2,mcx,teff1,teff2
      REAL*8 mass1i,mass2i,tbi,ecci,t_gw
      LOGICAL coel,com,prec,inttry,change,snova,sgl,bsymb,esymb,bss
      LOGICAL supedd,novae,disk
      LOGICAL isave,iplot
      REAL*8 rl,mlwind,vrotf,corerd
      EXTERNAL rl,mlwind,vrotf,corerd
      REAL bcm(50000,34),bpp(80,33)
      COMMON /BINARY/ bcm,bpp
*
*
* Save the initial state.
*
      mass1i = mass0(1)
      mass2i = mass0(2)
      tbi = tb
      ecci = ecc
*
      zero = 0.d0
      ngtv = -1.d0
      ngtv2 = -2.d0
      twopi = 2.d0*ACOS(-1.d0)
*
* Initialize the parameters.
*
      kmin = 1
      kmax = 2
      sgl = .false.
      mt2 = MIN(mass(1),mass(2))
      kst = 0
*
      if(mt2.lt.tiny.or.tb.le.0.d0)then
         sgl = .true.
         if(mt2.lt.tiny)then
            mt2 = 0.d0
            if(mass(1).lt.tiny)then
               if(tphys.lt.tiny)then
                  mass0(1) = 0.01d0
                  mass(1) = mass0(1)
                  kst = 1
               else
                  kmin = 2
                  lumin(1) = 1.0d-10
                  rad(1) = 1.0d-10
                  massc(1) = 0.d0
                  dmt(1) = 0.d0
                  dmr(1) = 0.d0
               endif
               ospin(1) = 1.0d-10
               jspin(1) = 1.0d-10
            else
               if(tphys.lt.tiny)then
                  mass0(2) = 0.01d0
                  mass(2) = mass0(2)
                  kst = 2
               else
                  kmax = 1
                  lumin(2) = 1.0d-10
                  rad(2) = 1.0d-10
                  massc(2) = 0.d0
                  dmt(2) = 0.d0
                  dmr(2) = 0.d0
               endif
               ospin(2) = 1.0d-10
               jspin(2) = 1.0d-10
            endif
         endif
         ecc = -1.d0
         tb = 0.d0
         sep = 1.0d+10
         oorb = 0.d0
         jorb = 0.d0
         if(ospin(1).lt.0.0) ospin(1) = 1.0d-10
         if(ospin(2).lt.0.0) ospin(2) = 1.0d-10
         q(1) = 1.0d+10
         q(2) = 1.0d+10
         rol(1) = 1.0d+10
         rol(2) = 1.0d+10
      else
         tb = tb/yeardy
         sep = aursun*(tb*tb*(mass(1) + mass(2)))**(1.d0/3.d0)
         oorb = twopi/tb
         jorb = mass(1)*mass(2)/(mass(1)+mass(2))
     &          *SQRT(1.d0-ecc*ecc)*sep*sep*oorb
         if(ospin(1).lt.0.d0) ospin(1) = oorb
         if(ospin(2).lt.0.d0) ospin(2) = oorb
      endif
*
      do 500 , k = kmin,kmax
         age = tphys - epoch(k)
         CALL star(kstar(k),mass0(k),mass(k),tm,tn,tscls,lums,GB,zpars)
         CALL hrdiag(mass0(k),age,mass(k),tm,tn,tscls,lums,GB,zpars,
     &               rm,lum,kstar(k),mc,rc,me,re,k2)
         aj(k) = age
         epoch(k) = tphys - age
         rad(k) = rm
         lumin(k) = lum
         massc(k) = mc
         radc(k) = rc
         menv(k) = me
         renv(k) = re
         k2str(k) = k2
         tms(k) = tm
         tbgb(k) = tscls(1)
*
         if(tphys.lt.tiny.and.ospin(k).le.0.001d0)then
            ospin(k) = 45.35d0*vrotf(mass(k))/rm
         endif
         jspin(k) = ospin(k)*(k2*rm*rm*(mass(k)-mc)+k3*rc*rc*mc)
         if(.not.sgl)then
            q(k) = mass(k)/mass(3-k)
            rol(k) = rl(q(k))*sep
         endif
         rol0(k) = rol(k)
         dmr(k) = 0.d0
         dmt(k) = 0.d0
         djspint(k) = 0.d0
         dtmi(k) = 1.0d+06
*
 500  continue
*
      if(mt2.lt.tiny)then
         sep = 0.d0
         if(kst.gt.0)then
            mass0(kst) = 0.d0
            mass(kst) = 0.d0
            kmin = 3 - kst
            kmax = kmin
         endif
      endif
*
* On the first entry the previous timestep is zero to prevent mass loss.
*
      dtm = 0.d0
      delet = 0.d0
      djorb = 0.d0
      bss = .false.
*
* Setup variables which control the output (if it is required).
*
      ip = 0
      jp = 0
      tsave = tphys
      isave = .true.
      iplot = .false.
      if(dtp.le.0.d0)then
         iplot = .true.
         isave = .false.
         tsave = tphysf
      elseif(dtp.gt.tphysf)then
         isave = .false.
         tsave = tphysf
      endif
      if(tphys.ge.tphysf) goto 140
*
 4    iter = 0
      intpol = 0
      inttry = .false.
      change = .false.
      prec = .false.
      snova = .false.
      coel = .false.
      com = .false.
      bsymb = .false.
      esymb = .false.
      tphys0 = tphys
      ecc1 = ecc
      j1 = 1
      j2 = 2
      if(kstar(1).ge.10.and.kstar(1).le.14) dtmi(1) = 0.01d0
      if(kstar(2).ge.10.and.kstar(2).le.14) dtmi(2) = 0.01d0
      dm1 = 0.d0
      dm2 = 0.d0
*
 5    kw1 = kstar(1)
      kw2 = kstar(2)
*
      dt = 1.0d+06*dtm
      eqspin = 0.d0
      djtt = 0.d0
*
      if(intpol.eq.0.and.ABS(dtm).gt.tiny.and..not.sgl)then
         vorb2 = acc1*(mass(1)+mass(2))/sep
         ivsqm = 1.d0/SQRT(1.d0-ecc*ecc)
         do 501 , k = 1,2
*
* Calculate wind mass loss from the previous timestep.
*
            if(neta.gt.tiny)then
               rlperi = rol(k)*(1.d0-ecc)
               dmr(k) = mlwind(kstar(k),lumin(k),rad(k),mass(k),
     &                         massc(k),rlperi,z)
*
* Calculate how much of wind mass loss from companion will be
* accreted (Boffin & Jorissen, A&A 1988, 205, 155).
*
               vwind2 = 2.d0*beta*acc1*mass(k)/rad(k)
               omv2 = (1.d0 + vorb2/vwind2)**(3.d0/2.d0)
               dmt(3-k) = ivsqm*acc2*dmr(k)*((acc1*mass(3-k)/vwind2)**2)
     &                    /(2.d0*sep*sep*omv2)
               dmt(3-k) = MIN(dmt(3-k),0.8d0*dmr(k))
            else
               dmr(k) = 0.d0
               dmt(3-k) = 0.d0
            endif
 501     continue
*
* Diagnostic for Symbiotic-type stars.
*
         if(neta.gt.tiny.and..not.esymb)then
            lacc = 3.14d+07*mass(j2)*dmt(j2)/rad(j2)
            lacc = lacc/lumin(j1)
            if((lacc.gt.0.01d0.and..not.bsymb).or.
     &         (lacc.lt.0.01d0.and.bsymb))then
                jp = MIN(80,jp + 1)
                bpp(jp,1) = tphys
                bpp(jp,2) = float(kstar(1))
                bpp(jp,3) = mass0(1)
                bpp(jp,4) = mass(1)
                bpp(jp,5) = log10(lumin(1))
                bpp(jp,6) = log10(rad(1))
                teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                              (rad(1)**2.d0))**(1.d0/4.d0))
                bpp(jp,7) = log10(teff1)
                bpp(jp,8) = massc(1)
                bpp(jp,9) = radc(1)
                bpp(jp,10) = menv(1)
                bpp(jp,11) = renv(1)
                bpp(jp,12) = epoch(1)
                bpp(jp,13) = ospin(1)
                bpp(jp,14) = dmt(1) - dmr(1)
                bpp(jp,15) = rad(1)/rol(1)
                bpp(jp,16) = float(kstar(2))
                bpp(jp,17) = mass0(2)
                bpp(jp,18) = mass(2)
                bpp(jp,19) = log10(lumin(2))
                bpp(jp,20) = log10(rad(2))
                teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                               (rad(2)**2.d0))**(1.d0/4.d0))
                bpp(jp,21) = log10(teff2)
                bpp(jp,22) = massc(2)
                bpp(jp,23) = radc(2)
                bpp(jp,24) = menv(2)
                bpp(jp,25) = renv(2)
                bpp(jp,26) = epoch(2)
                bpp(jp,27) = ospin(2)
                bpp(jp,28) = dmt(2) - dmr(2)
                bpp(jp,29) = rad(2)/rol(2)
                bpp(jp,30) = tb
                bpp(jp,31) = sep
                bpp(jp,32) = ecc
                if(bsymb)then
                    bpp(jp,33) = 13.0
                    esymb = .true.
                else
                    bpp(jp,33) = 12.0
                    bsymb = .true.
                endif
            endif
         endif
*
* Calculate orbital angular momentum change due to wind mass loss.
*
         ecc2 = ecc*ecc
         omecc2 = 1.d0 - ecc2
         sqome2 = SQRT(omecc2)
*
         djorb = ((dmr(1)+q(1)*dmt(1))*mass(2)*mass(2) + 
     &            (dmr(2)+q(2)*dmt(2))*mass(1)*mass(1))*
     &           sep*sep*sqome2*oorb/(mass(1)+mass(2))**2
         delet = ecc*(dmt(1)*(0.5d0/mass(1) + 1.d0/(mass(1)+mass(2))) +
     &                dmt(2)*(0.5d0/mass(2) + 1.d0/(mass(1)+mass(2))))
*
* For very close systems include angular momentum loss owing to 
* gravitational radiation. 
*
* Compute the merging time due to gw emission:
*	t_gw = 1/256 * c^5/G^3 * [a^4*(1 - e^2)^(7/2)]/[mass(1)*mass(2)*(m1 + m2)]
* where c = 1.3594037*10^7 [Rsun / yr] 
*       G = 3.9227785*10^8 [Rsun^3 / (Msun * yr^2)]
*
*         t_gw = 5.d0/256.d0*(1.3594037d0*10**7)**5/
*     &       (3.9227785d0*10**8)**3*
*     &	     sep**4*(1 - ecc2)**(7.d0/2.d0)/
*     &       (mass(1)*mass(2)*(mass(1)+mass(2)))/(10**6)
*
* ... but probably it's better to evolve the system in any case
      t_gw = 0.0
* GWs are important only for compact objects
	  if((kstar(1).ge.10 .and. kstar(2).ge.10).and.t_gw.le.tphysf)then
            djgr = 8.315d-10*mass(1)*mass(2)*(mass(1)+mass(2))/
     &             (sep*sep*sep*sep)
            f1 = (19.d0/6.d0) + (121.d0/96.d0)*ecc2
            sqome5 = sqome2**5
            delet1 = djgr*ecc*f1/sqome5
            djgr = djgr*jorb*(1.d0+0.875d0*ecc2)/sqome5
            djorb = djorb + djgr
            delet = delet + delet1
         endif
*
         do 502 , k = 1,2
*
* Calculate change in the intrinsic spin of the star.
*
            djtx(k) = (2.d0/3.d0)*xi*dmt(k)*rad(3-k)*rad(3-k)*ospin(3-k)
            djspint(k) = (2.d0/3.d0)*(dmr(k)*rad(k)*rad(k)*ospin(k)) -
     &                   djtx(k)
*
* Include magnetic braking for stars that have appreciable convective 
* envelopes. This includes MS stars with M < 1.25, HG stars near the GB 
* and giants. MB is not allowed for fully convective MS stars. 
*
            if(mass(k).gt.0.35d0.and.kstar(k).lt.10)then
               djmb = 5.83d-16*menv(k)*(rad(k)*ospin(k))**3/mass(k)
               djspint(k) = djspint(k) + djmb
*
* Limit to a 3% angular momentum change for the star owing to MB. 
* This is found to work best with the maximum iteration of 20000, 
* i.e. does not create an excessive number of iterations, while not 
* affecting the evolution outcome when compared with a 2% restriction.  
*
               if(djmb.gt.tiny)then
                  dtj = 0.03d0*jspin(k)/ABS(djmb)
                  dt = MIN(dt,dtj)
               endif
            endif
*
* Calculate circularization, orbital shrinkage and spin up.
*
            dspint(k) = 0.d0
            if(((kstar(k).le.9.and.rad(k).ge.0.01d0*rol(k)).or.
     &         (kstar(k).ge.10.and.k.eq.j1)).and.tflag.gt.0)then
*
               raa2 = (rad(k)/sep)**2
               raa6 = raa2**3
*
* Hut's polynomials.
*
               f5 = 1.d0+ecc2*(3.d0+ecc2*0.375d0)
               f4 = 1.d0+ecc2*(1.5d0+ecc2*0.125d0)
               f3 = 1.d0+ecc2*(3.75d0+ecc2*(1.875d0+ecc2*7.8125d-02))
               f2 = 1.d0+ecc2*(7.5d0+ecc2*(5.625d0+ecc2*0.3125d0))
               f1 = 1.d0+ecc2*(15.5d0+ecc2*(31.875d0+ecc2*(11.5625d0
     &                  +ecc2*0.390625d0)))
*
               if((kstar(k).eq.1.and.mass(k).ge.1.25d0).or.
     &            kstar(k).eq.4.or.kstar(k).eq.7)then
*
* Radiative damping (Zahn, 1977, A&A, 57, 383 and 1975, A&A, 41, 329).
*
                  tc = 1.592d-09*(mass(k)**2.84d0)
                  f = 1.9782d+04*SQRT((mass(k)*rad(k)*rad(k))/sep**5)*
     &                tc*(1.d0+q(3-k))**(5.d0/6.d0)
                  tcqr = f*q(3-k)*raa6
                  rg2 = k2str(k)
               elseif(kstar(k).le.9)then
*
* Convective damping (Hut, 1981, A&A, 99, 126).
*
                  tc = mr23yr*(menv(k)*renv(k)*(rad(k)-0.5d0*renv(k))/
     &                 (3.d0*lumin(k)))**(1.d0/3.d0)
                  ttid = twopi/(1.0d-10 + ABS(oorb - ospin(k)))
*                  f = MIN(1.d0,(ttid/(2.d0*tc)**2))
                  f = MIN(1.d0,(ttid/(2.d0*tc))**2)
                  tcqr = 2.d0*f*q(3-k)*raa6*menv(k)/(21.d0*tc*mass(k))
                  rg2 = (k2str(k)*(mass(k)-massc(k)))/mass(k)
               else
*
* Degenerate damping (Campbell, 1984, MNRAS, 207, 433)
*
                  f = 7.33d-09*(lumin(k)/mass(k))**(5.d0/7.d0)
                  tcqr = f*q(3-k)*q(3-k)*raa2*raa2/(1.d0+q(3-k))
                  rg2 = k3
               endif
*
* Circularization.
*
               sqome3 = sqome2**3
               delet1 = 27.d0*tcqr*(1.d0+q(3-k))*raa2*(ecc/sqome2**13)*
     &                  (f3 - (11.d0/18.d0)*sqome3*f4*ospin(k)/oorb)
               tcirc = ecc/(ABS(delet1) + 1.0d-20)
               delet = delet + delet1
*
* Spin up of star.
*
               dspint(k) = (3.d0*q(3-k)*tcqr/(rg2*omecc2**6))*
     &                     (f2*oorb - sqome3*f5*ospin(k))
*
* Calculate the equilibrium spin at which no angular momentum 
* can be transferred.
*
               eqspin = oorb*f2/(sqome3*f5)
*
* Calculate angular momentum change for the star owing to tides. 
*
               djt = (k2str(k)*(mass(k)-massc(k))*rad(k)*rad(k) +
     &                k3*massc(k)*radc(k)*radc(k))*dspint(k)
               if(kstar(k).le.6.or.ABS(djt)/jspin(k).gt.0.1d0)then
                  djtt = djtt + djt
               endif
            endif
 502     continue
*
* Limit to 2% orbital angular momentum change.
*
         djtt = djtt + djorb 
         if(ABS(djtt).gt.tiny)then
            dtj = 0.02d0*jorb/ABS(djtt)
            dt = MIN(dt,dtj)
         endif
         dtm = dt/1.0d+06
*
      elseif(ABS(dtm).gt.tiny.and.sgl)then
         do 503 , k = kmin,kmax
            if(neta.gt.tiny)then
               rlperi = 0.d0
               dmr(k) = mlwind(kstar(k),lumin(k),rad(k),mass(k),
     &                         massc(k),rlperi,z)
            else
               dmr(k) = 0.d0
            endif
            dmt(k) = 0.d0
            djspint(k) = (2.d0/3.d0)*dmr(k)*rad(k)*rad(k)*ospin(k)
            if(mass(k).gt.0.35d0.and.kstar(k).lt.10)then
               djmb = 5.83d-16*menv(k)*(rad(k)*ospin(k))**3/mass(k)
               djspint(k) = djspint(k) + djmb
               if(djmb.gt.tiny)then
                  dtj = 0.03d0*jspin(k)/ABS(djmb)
                  dt = MIN(dt,dtj)
               endif
            endif
*
 503     continue
         dtm = dt/1.0d+06
      endif
*
      do 504 , k = kmin,kmax
*
         dms(k) = (dmr(k) - dmt(k))*dt
         if(kstar(k).lt.10)then
            dml = mass(k) - massc(k)
            if(dml.lt.dms(k))then
               dml = MAX(dml,2.d0*tiny)
               dtm = (dml/dms(k))*dtm
               if(k.eq.2) dms(1) = dms(1)*dml/dms(2)
               dms(k) = dml
               dt = 1.0d+06*dtm
            endif
*
* Limit to 1% mass loss.
*
            if(dms(k).gt.0.01d0*mass(k))then
               dtm = 0.01d0*mass(k)*dtm/dms(k)
               if(k.eq.2) dms(1) = dms(1)*0.01d0*mass(2)/dms(2)
               dms(k) = 0.01d0*mass(k)
               dt = 1.0d+06*dtm
            endif
         endif
*
 504  continue
*
* Update mass and intrinsic spin (checking that the star is not spun 
* past the equilibrium) and reset epoch for a MS (and possibly a HG) star. 
*
      do 505 , k = kmin,kmax
*
         if(eqspin.gt.0.d0.and.ABS(dspint(k)).gt.tiny)then
            if(intpol.eq.0)then
               if(dspint(k).ge.0.d0)then
                  dspint(k) = MIN(dspint(k),(eqspin-ospin(k))/dt)
               else
                  dspint(k) = MAX(dspint(k),(eqspin-ospin(k))/dt)
               endif
               djt = (k2str(k)*(mass(k)-massc(k))*rad(k)*rad(k) +
     &                k3*massc(k)*radc(k)*radc(k))*dspint(k)
               djorb = djorb + djt
               djspint(k) = djspint(k) - djt
            endif
         endif
*
         jspin(k) = MAX(1.0d-10,jspin(k) - djspint(k)*dt)
*
* Ensure that the star does not spin up beyond break-up.
*
         ospbru = twopi*SQRT(mass(k)*aursun**3/rad(k)**3)
         jspbru = (k2str(k)*(mass(k)-massc(k))*rad(k)*rad(k) +
     &             k3*massc(k)*radc(k)*radc(k))*ospbru
         if(jspin(k).gt.jspbru.and.ABS(dtm).gt.tiny)then
            mew = 1.d0
            if(djtx(k).gt.0.d0)then
               mew = MIN(mew,(jspin(k) - jspbru)/djtx(k))
            endif
            jspin(k) = jspbru
* If excess material should not be accreted, activate next line.
*           dms(k) = dms(k) + (1.d0 - mew)*dmt(k)*dt
         endif
*
         if(ABS(dms(k)).gt.tiny)then
            mass(k) = mass(k) - dms(k)
            if(kstar(k).le.2.or.kstar(k).eq.7)then
               m0 = mass0(k)
               mass0(k) = mass(k)
               CALL star(kstar(k),mass0(k),mass(k),tm,tn,tscls,
     &                   lums,GB,zpars)
               if(kstar(k).eq.2)then
                  if(GB(9).lt.massc(k).or.m0.gt.zpars(3))then
                     mass0(k) = m0
                  else
                     epoch(k) = tm + (tscls(1) - tm)*(aj(k)-tms(k))/
     &                               (tbgb(k) - tms(k))
                     epoch(k) = tphys - epoch(k)
                  endif
               else
                  epoch(k) = tphys - aj(k)*tm/tms(k)
               endif
            endif
         endif
*
 505  continue
*
      if(.not.sgl)then
*
         ecc1 = ecc1 - delet*dt
         ecc = MAX(ecc1,0.d0)
         if(ecc.lt.1.0d-10) ecc = 0.d0
*
         if(ecc.ge.1.d0) goto 135
*
         jorb = jorb - djorb*dt
         sep = (mass(1) + mass(2))*jorb*jorb/
     &         ((mass(1)*mass(2)*twopi)**2*aursun**3*(1.d0-ecc*ecc))
         tb = (sep/aursun)*SQRT(sep/(aursun*(mass(1)+mass(2))))
         oorb = twopi/tb
      endif
*
* Advance the time.
*
      if(intpol.eq.0)then
         tphys0 = tphys
         dtm0 = dtm
      endif
      tphys = tphys + dtm
*
      do 6 , k = kmin,kmax
*
* Acquire stellar parameters (M, R, L, Mc & K*) at apparent evolution age.
*
         age = tphys - epoch(k)
         aj0(k) = age
         kw = kstar(k)
         m0 = mass0(k)
         mt = mass(k)
         mc = massc(k)
         if(intpol.eq.0) mcxx(k) = mc
         if(intpol.gt.0) mc = mcxx(k)
         mass00(k) = m0
*
* Masses over 150Msun should probably not be trusted in the
* evolution formulae.
*
         if(mt.gt.150.d0)then
            WRITE(99,*)' MASS EXCEEDED in evolv3.f',mass1i,mass2i,
     &                 tbi,ecci,mt
            goto 140
         endif
*
         CALL star(kw,m0,mt,tm,tn,tscls,lums,GB,zpars)
         CALL hrdiag(m0,age,mt,tm,tn,tscls,lums,GB,zpars,
     &               rm,lum,kw,mc,rc,me,re,k2)
*
         if(kw.ne.15)then
            ospin(k) = jspin(k)/(k2*(mt-mc)*rm*rm+k3*mc*rc*rc)
         endif
*
* At this point there may have been a supernova.
*
         if(kw.ne.kstar(k).and.kstar(k).le.12.and.
     &      (kw.eq.13.or.kw.eq.14))then
            if(sgl)then
               CALL kick(kw,mass(k),mt,0.d0,0.d0,-1.d0,0.d0,vs)
            else
               CALL kick(kw,mass(k),mt,mass(3-k),ecc,sep,jorb,vs)
               if(ecc.gt.1.d0)then
                  kstar(k) = kw
                  mass(k) = mt
                  epoch(k) = tphys - age
                  goto 135
               endif
               tb = (sep/aursun)*SQRT(sep/(aursun*(mt+mass(3-k))))
               oorb = twopi/tb
            endif
            snova = .true.
         endif
*
         if(kw.ne.kstar(k))then
            change = .true.
            mass(k) = mt
            dtmi(k) = 0.01d0
            if(kw.eq.15)then
               kstar(k) = kw
               goto 135
            endif
            mass0(k) = m0
            epoch(k) = tphys - age
            if(kw.gt.6.and.kstar(k).le.6)then
               bsymb = .false.
               esymb = .false.
            endif
         endif
*
* Force new NS or BH to have a second period.
*
         if(kstar(k).eq.13.or.kstar(k).eq.14)then
            if(tphys-epoch(k).lt.tiny)then
               ospin(k) = 2.0d+08
               jspin(k) = k3*rc*rc*mc*ospin(k)
            endif
         endif
*
* Set radius derivative for later interpolation.
*
         if(ABS(dtm).gt.tiny)then
            rdot(k) = ABS(rm - rad(k))/dtm
         else
            rdot(k) = 0.d0
         endif
*
* Base new time scale for changes in radius & mass on stellar type.
*
         dt = dtmi(k)
         CALL deltat(kw,age,tm,tn,tscls,dt,dtr)
*
* Choose minimum of time-scale and remaining interval.
*
         dtmi(k) = MIN(dt,dtr)
*
* Save relevent solar quantities.
*
         aj(k) = age
         kstar(k) = kw
         rad(k) = rm
         lumin(k) = lum
         massc(k) = mc
         radc(k) = rc
         menv(k) = me
         renv(k) = re
         k2str(k) = k2
         tms(k) = tm
         tbgb(k) = tscls(1)
*
* Check for blue straggler formation. 
*
         if(kw.le.1.and.tm.lt.tphys.and..not.bss)then
            bss = .true.
            jp = MIN(80,jp + 1)
            bpp(jp,1) = tphys
            bpp(jp,2) = float(kstar(1))
            bpp(jp,3) = mass0(1)
            bpp(jp,4) = mass(1)
            bpp(jp,5) = log10(lumin(1))
            bpp(jp,6) = log10(rad(1))
            teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                          (rad(1)**2.d0))**(1.d0/4.d0))
            bpp(jp,7) = log10(teff1)
            bpp(jp,8) = massc(1)
            bpp(jp,9) = radc(1)
            bpp(jp,10) = menv(1)
            bpp(jp,11) = renv(1)
            bpp(jp,12) = epoch(1)
            bpp(jp,13) = ospin(1)
            bpp(jp,14) = dmt(1) - dmr(1)
            bpp(jp,15) = rad(1)/rol(1)
            bpp(jp,16) = float(kstar(2))
            bpp(jp,17) = mass0(2)
            bpp(jp,18) = mass(2)
            bpp(jp,19) = log10(lumin(2))
            bpp(jp,20) = log10(rad(2))
            teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                          (rad(2)**2.d0))**(1.d0/4.d0))
            bpp(jp,21) = log10(teff2)
            bpp(jp,22) = massc(2)
            bpp(jp,23) = radc(2)
            bpp(jp,24) = menv(2)
            bpp(jp,25) = renv(2)
            bpp(jp,26) = epoch(2)
            bpp(jp,27) = ospin(2)
            bpp(jp,28) = dmt(2) - dmr(2)
            bpp(jp,29) = rad(2)/rol(2)
            bpp(jp,30) = tb
            bpp(jp,31) = sep
            bpp(jp,32) = ecc
            bpp(jp,33) = 14.0
         endif
*
 6    continue
*
      if(.not.sgl)then
*
* Determine the mass ratios.
*
         do 506 , k = 1,2
            q(k) = mass(k)/mass(3-k)
 506     continue
*
* Determine the Roche lobe radii and adjust the radius derivative.
*
         do 507 , k = 1,2
            rol(k) = rl(q(k))*sep
            if(ABS(dtm).gt.tiny)then
               rdot(k) = rdot(k) + (rol(k) - rol0(k))/dtm
               rol0(k) = rol(k)
            endif
 507     continue
      else
         do 508 , k = kmin,kmax
            rol(k) = 10000.d0*rad(k)
 508     continue
      endif
*
      if((tphys.lt.tiny.and.ABS(dtm).lt.tiny.and.
     &    (mass2i.lt.0.1d0.or..not.sgl)).or.snova)then
         jp = MIN(80,jp + 1)
         bpp(jp,1) = tphys
         bpp(jp,2) = float(kstar(1))
         bpp(jp,3) = mass0(1)
         bpp(jp,4) = mass(1)
         bpp(jp,5) = log10(lumin(1))
         bpp(jp,6) = log10(rad(1))
         teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                    (rad(1)**2.d0))**(1.d0/4.d0))
         bpp(jp,7) = log10(teff1)
         bpp(jp,8) = massc(1)
         bpp(jp,9) = radc(1)
         bpp(jp,10) = menv(1)
         bpp(jp,11) = renv(1)
         bpp(jp,12) = epoch(1)
         bpp(jp,13) = ospin(1)
         bpp(jp,14) = dmt(1) - dmr(1)
         bpp(jp,15) = rad(1)/rol(1)
         bpp(jp,16) = float(kstar(2))
         bpp(jp,17) = mass0(2)
         bpp(jp,18) = mass(2)
         bpp(jp,19) = log10(lumin(2))
         bpp(jp,20) = log10(rad(2))
         teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                    (rad(2)**2.d0))**(1.d0/4.d0))
         bpp(jp,21) = log10(teff2)
         bpp(jp,22) = massc(2)
         bpp(jp,23) = radc(2)
         bpp(jp,24) = menv(2)
         bpp(jp,25) = renv(2)
         bpp(jp,26) = epoch(2)
         bpp(jp,27) = ospin(2)
         bpp(jp,28) = dmt(2) - dmr(2)
         bpp(jp,29) = rad(2)/rol(2)
         bpp(jp,30) = tb
         bpp(jp,31) = sep
         bpp(jp,32) = ecc
         bpp(jp,33) = 1.0
         if(snova)then
            bpp(jp,33) = 2.0
            dtm = 0.d0
            goto 4
         endif
      endif
*
      if((isave.and.tphys.ge.tsave).or.iplot)then
         if(sgl.or.(rad(1).lt.rol(1).and.rad(2).lt.rol(2)).
     &      or.tphys.lt.tiny)then
            ip = ip + 1
            bcm(ip,1) = tphys
            bcm(ip,2) = float(kstar(1))
            bcm(ip,3) = mass0(1)
            bcm(ip,4) = mass(1)
            bcm(ip,5) = log10(lumin(1))
            bcm(ip,6) = log10(rad(1))
            teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad(1)**2.d0))**(1.d0/4.d0))
            bcm(ip,7) = log10(teff1)
            bcm(ip,8) = massc(1)
            bcm(ip,9) = radc(1)
            bcm(ip,10) = menv(1)
            bcm(ip,11) = renv(1)
            bcm(ip,12) = epoch(1)
            bcm(ip,13) = ospin(1)
            bcm(ip,14) = dmt(1) - dmr(1)
            bcm(ip,15) = rad(1)/rol(1)
            bcm(ip,16) = float(kstar(2))
            bcm(ip,17) = mass0(2)
            bcm(ip,18) = mass(2)
            bcm(ip,19) = log10(lumin(2))
            bcm(ip,20) = log10(rad(2))
            teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad(2)**2.d0))**(1.d0/4.d0))
            bcm(ip,21) = log10(teff2)
            bcm(ip,22) = massc(2)
            bcm(ip,23) = radc(2)
            bcm(ip,24) = menv(2)
            bcm(ip,25) = renv(2)
            bcm(ip,26) = epoch(2)
            bcm(ip,27) = ospin(2)
            bcm(ip,28) = dmt(2) - dmr(2)
            bcm(ip,29) = rad(2)/rol(2)
            bcm(ip,30) = tb
            bcm(ip,31) = sep
            bcm(ip,32) = ecc
            if(isave) tsave = tsave + dtp
         endif
      endif
*
* If not interpolating set the next timestep.
*
      if(intpol.eq.0)then
         dtm = MAX(1.0d-07*tphys,MIN(dtmi(1),dtmi(2)))
         dtm = MIN(dtm,tsave-tphys)
         if(iter.eq.0) dtm0 = dtm
      endif
*
      if(sgl) goto 98
*
* Set j1 to the donor - the primary
* and j2 to the accretor - the secondary.
*
      if(intpol.eq.0)then
         if(rad(1)/rol(1).ge.rad(2)/rol(2))then
            j1 = 1
            j2 = 2
         else
            j1 = 2
            j2 = 1
         endif
      endif
*
* Test whether Roche lobe overflow has begun.
*
      if(rad(j1).gt.rol(j1))then
*
* Interpolate back until the primary is just filling its Roche lobe.
*
         if(rad(j1).ge.1.002d0*rol(j1))then
            if(intpol.eq.0) tphys00 = tphys
            intpol = intpol + 1
            if(iter.eq.0) goto 7
            if(inttry) goto 7
            if(intpol.ge.100)then
               WRITE(99,*)' INTPOL EXCEEDED ',mass1i,mass2i,tbi,ecci
               goto 140 
            endif
            dr = rad(j1) - 1.001d0*rol(j1)
            if(ABS(rdot(j1)).lt.tiny.or.prec)then
               goto 7
            endif
            dtm = -dr/ABS(rdot(j1))
            if(ABS(tphys0-tphys).gt.tiny) dtm = MAX(dtm,tphys0-tphys)
            if(kstar(1).ne.kw1)then
               kstar(1) = kw1
               mass0(1) = mass00(1)
               epoch(1) = tphys - aj0(1)
            endif
            if(kstar(2).ne.kw2)then
               kstar(2) = kw2
               mass0(2) = mass00(2)
               epoch(2) = tphys - aj0(2)
            endif
            change = .false.
         else
*
* Enter Roche lobe overflow
*
            if(tphys.ge.tphysf) goto 140
            goto 7
         endif
      else
*
* Check if already interpolating.
*
         if(intpol.gt.0)then
            intpol = intpol + 1
            if(intpol.ge.80)then
               inttry = .true.
            endif
            if(ABS(rdot(j1)).lt.tiny)then
               prec = .true.
               dtm = 1.0d-07*tphys
            else
               dr = rad(j1) - 1.001d0*rol(j1)
               dtm = -dr/ABS(rdot(j1))
            endif
            if((tphys+dtm).ge.tphys00)then
*
* If this occurs then most likely the star is a high mass type 4
* where the radius can change very sharply or possibly there is a 
* discontinuity in the radius as a function of time and HRDIAG
* needs to be checked!
*
               dtm = 0.5d0*(tphys00 - tphys0)
               dtm = MAX(dtm,1.0d-10)
               prec = .true.
            endif
            tphys0 = tphys
         endif
      endif
*
* Check for collision at periastron.
*
      pd = sep*(1.d0 - ecc)
      if(pd.lt.(rad(1)+rad(2)).and.intpol.eq.0) goto 130
*
* Go back for the next step or interpolation.
*
 98   continue
*
      if(tphys.ge.tphysf.and.intpol.eq.0) goto 140
      if(change)then
         change = .false.
         jp = MIN(80,jp + 1)
         bpp(jp,1) = tphys
         bpp(jp,2) = float(kstar(1))
         bpp(jp,3) = mass0(1)
         bpp(jp,4) = mass(1)
         bpp(jp,5) = log10(lumin(1))
         bpp(jp,6) = log10(rad(1))
         teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                        (rad(1)**2.d0))**(1.d0/4.d0))
         bpp(jp,7) = log10(teff1)
         bpp(jp,8) = massc(1)
         bpp(jp,9) = radc(1)
         bpp(jp,10) = menv(1)
         bpp(jp,11) = renv(1)
         bpp(jp,12) = epoch(1)
         bpp(jp,13) = ospin(1)
         bpp(jp,14) = dmt(1) - dmr(1)
         bpp(jp,15) = rad(1)/rol(1)
         bpp(jp,16) = float(kstar(2))
         bpp(jp,17) = mass0(2)
         bpp(jp,18) = mass(2)
         bpp(jp,19) = log10(lumin(2))
         bpp(jp,20) = log10(rad(2))
         teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                        (rad(2)**2.d0))**(1.d0/4.d0))
         bpp(jp,21) = log10(teff2)
         bpp(jp,22) = massc(2)
         bpp(jp,23) = radc(2)
         bpp(jp,24) = menv(2)
         bpp(jp,25) = renv(2)
         bpp(jp,26) = epoch(2)
         bpp(jp,27) = ospin(2)
         bpp(jp,28) = dmt(2) - dmr(2)
         bpp(jp,29) = rad(2)/rol(2)
         bpp(jp,30) = tb
         bpp(jp,31) = sep
         bpp(jp,32) = ecc
         bpp(jp,33) = 2.0
      endif
*
      iter = iter + 1
*
      if(iter.ge.loop)then
         WRITE(99,*)' MAXIMUM ITER EXCEEDED ',mass1i,mass2i,tbi,ecci
         goto 140
      endif
      goto 5
*
* Set the nuclear timescale in years and slow-down factor.
*
 7    km0 = dtm0*1.0d+03/tb
      if(km0.lt.tiny) km0 = 0.5d0
*
* Force co-rotation of primary and orbit to ensure that the tides do not
* lead to unstable Roche (not currently used).
*
*     if(ospin(j1).gt.1.05d0*oorb)then
*        ospin(j1) = oorb
*        jspin(j1) = (k2str(j1)*rad(j1)*rad(j1)*(mass(j1)-massc(j1))+
*    &                k3*radc(j1)*radc(j1)*massc(j1))*ospin(j1)
*     endif
*
      iter = 0
      coel = .false.
      change = .false.
      radx(j1) = MAX(radc(j1),rol(j1))
      radx(j2) = rad(j2)
*
      jp = MIN(80,jp + 1)
      bpp(jp,1) = tphys
      bpp(jp,2) = float(kstar(1))
      bpp(jp,3) = mass0(1)
      bpp(jp,4) = mass(1)
      bpp(jp,5) = log10(lumin(1))
      bpp(jp,6) = log10(rad(1))
      teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                   (rad(1)**2.d0))**(1.d0/4.d0))
      bpp(jp,7) = log10(teff1)
      bpp(jp,8) = massc(1)
      bpp(jp,9) = radc(1)
      bpp(jp,10) = menv(1)
      bpp(jp,11) = renv(1)
      bpp(jp,12) = epoch(1)
      bpp(jp,13) = ospin(1)
      bpp(jp,14) = dmt(1) - dmr(1)
      bpp(jp,15) = rad(1)/rol(1)
      bpp(jp,16) = float(kstar(2))
      bpp(jp,17) = mass0(2)
      bpp(jp,18) = mass(2)
      bpp(jp,19) = log10(lumin(2))
      bpp(jp,20) = log10(rad(2))
      teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                    (rad(2)**2.d0))**(1.d0/4.d0))
      bpp(jp,21) = log10(teff2)
      bpp(jp,22) = massc(2)
      bpp(jp,23) = radc(2)
      bpp(jp,24) = menv(2)
      bpp(jp,25) = renv(2)
      bpp(jp,26) = epoch(2)
      bpp(jp,27) = ospin(2)
      bpp(jp,28) = dmt(2) - dmr(2)
      bpp(jp,29) = rad(2)/rol(2)
      bpp(jp,30) = tb
      bpp(jp,31) = sep
      bpp(jp,32) = ecc
      bpp(jp,33) = 3.0
*
      if(iplot.and.tphys.gt.tiny)then
         ip = ip + 1
         bcm(ip,1) = tphys
         bcm(ip,2) = float(kstar(1))
         bcm(ip,3) = mass0(1)
         bcm(ip,4) = mass(1)
         bcm(ip,5) = log10(lumin(1))
         bcm(ip,6) = log10(rad(1))
         teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                    (rad(1)**2.d0))**(1.d0/4.d0))
         bcm(ip,7) = log10(teff1)
         bcm(ip,8) = massc(1)
         bcm(ip,9) = radc(1)
         bcm(ip,10) = menv(1)
         bcm(ip,11) = renv(1)
         bcm(ip,12) = epoch(1)
         bcm(ip,13) = ospin(1)
         bcm(ip,14) = 0.0
         bcm(ip,15) = rad(1)/rol(1)
         bcm(ip,16) = float(kstar(2))
         bcm(ip,17) = mass0(2)
         bcm(ip,18) = mass(2)
         bcm(ip,19) = log10(lumin(2))
         bcm(ip,20) = log10(rad(2))
         teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                    (rad(2)**2.d0))**(1.d0/4.d0))
         bcm(ip,21) = log10(teff2)
         bcm(ip,22) = massc(2)
         bcm(ip,23) = radc(2)
         bcm(ip,24) = menv(2)
         bcm(ip,25) = renv(2)
         bcm(ip,26) = epoch(2)
         bcm(ip,27) = ospin(2)
         bcm(ip,28) = 0.0
         bcm(ip,29) = rad(2)/rol(2)
         bcm(ip,30) = tb
         bcm(ip,31) = sep
         bcm(ip,32) = ecc
      endif
*
* Eddington limit for accretion on to the secondary in one orbit.
*
 8    dme = 2.08d-03*eddfac*(1.d0/(1.d0 + zpars(11)))*rad(j2)*tb
      supedd = .false.
      novae = .false.
      disk = .false.
*
* Determine whether the transferred material forms an accretion 
* disk around the secondary or hits the secondary in a direct 
* stream, by using eq.(1) of Ulrich & Burger (1976, ApJ, 206, 509) 
* fitted to the calculations of Lubow & Shu (1974, ApJ, 198, 383). 
*
*     if(kstar(j2).ge.10) disk = .true.
      rmin = 0.0425d0*sep*(q(j2)*(1.d0+q(j2)))**(1.d0/4.d0)
      if(rmin.gt.rad(j2)) disk = .true.
*
* Kelvin-Helmholtz time from the modified classical expression.
*
      do 13 , k = 1,2
         tkh(k) = 1.0d+07*mass(k)/(rad(k)*lumin(k))
         if(kstar(k).le.1.or.kstar(k).eq.7.or.kstar(k).ge.10)then
            tkh(k) = tkh(k)*mass(k)
         else
            tkh(k) = tkh(k)*(mass(k) - massc(k))
         endif
 13   continue
*
* Dynamical timescale for the primary.
*
      tdyn = 5.05d-05*SQRT(rad(j1)**3/mass(j1))
*
* Identify special cases.
*
      if(kstar(j1).eq.2)then
         qc = 4.d0
      elseif(kstar(j1).eq.3.or.kstar(j1).eq.5.or.kstar(j1).eq.6)then
*        qc = (1.67d0-zpars(7)+2.d0*(massc(j1)/mass(j1))**5)/2.13d0
* Alternatively use condition of Hjellming & Webbink, 1987, ApJ, 318, 794. 
         qc = 0.362 + 1.0/(3.0*(1.0 - massc(j1)/mass(j1)))
* Or allow all cases to avoid common-envelope.  
*        qc = 100.d0
      elseif(kstar(j1).eq.8.or.kstar(j1).eq.9)then
         qc = 0.784d0
      else
         qc = 3.d0
      endif
*
      if(kstar(j1).eq.0.and.q(j1).gt.0.695d0)then
*
* This will be dynamical mass transfer of a similar nature to
* common-envelope evolution.  The result is always a single
* star placed in *2.
*
         taum = SQRT(tkh(j1)*tdyn)
         dm1 = mass(j1)
         if(kstar(j2).le.1)then
*
* Restrict accretion to thermal timescale of secondary.
*
            dm2 = taum/tkh(j2)*dm1
            mass(j2) = mass(j2) + dm2
*
* Rejuvenate if the star is still on the main sequence.
*
            mass0(j2) = mass(j2)
            CALL star(kstar(j2),mass0(j2),mass(j2),tmsnew,tn,
     &                tscls,lums,GB,zpars)
* If the star has no convective core then the effective age decreases,
* otherwise it will become younger still.
            if(mass(j2).lt.0.35d0.or.mass(j2).gt.1.25d0)then
               aj(j2) = tmsnew/tms(j2)*aj(j2)*(mass(j2) - dm2)/mass(j2)
            else
               aj(j2) = tmsnew/tms(j2)*aj(j2)
            endif
            epoch(j2) = tphys - aj(j2)
         elseif(kstar(j2).le.6)then
*
* Add all the material to the giant's envelope.
*
            dm2 = dm1
            mass(j2) = mass(j2) + dm2
            if(kstar(j2).eq.2)then
               mass0(j2) = mass(j2)
               CALL star(kstar(j2),mass0(j2),mass(j2),tmsnew,tn,tscls,
     &                   lums,GB,zpars)
               aj(j2) = tmsnew + tscls(1)*(aj(j2)-tms(j2))/tbgb(j2)
               epoch(j2) = tphys - aj(j2)
            endif
         elseif(kstar(j2).le.12)then
*
* Form a new giant envelope.
*
            dm2 = dm1
            kst = ktype(kstar(j1),kstar(j2))
            if(kst.gt.100) kst = kst - 100
            if(kst.eq.4)then
               aj(j2) = aj(j2)/tms(j2)
               massc(j2) = mass(j2)
            endif
*
* Check for planets or low-mass WDs.
*
            if((kstar(j2).eq.10.and.mass(j2).lt.0.05d0).or.
     &         (kstar(j2).ge.11.and.mass(j2).lt.0.5d0))then
               kst = kstar(j1)
               mass(j1) = mass(j2) + dm2
               mass(j2) = 0.d0
            else
               mass(j2) = mass(j2) + dm2
               CALL gntage(massc(j2),mass(j2),kst,zpars,
     &                     mass0(j2),aj(j2))
               epoch(j2) = tphys - aj(j2)
            endif
            kstar(j2) = kst
         else
*
* The neutron star or black hole simply accretes at the Eddington rate.
*
            dm2 = MIN(dme*taum/tb,dm1)
            if(dm2.lt.dm1) supedd = .true. 
            mass(j2) = mass(j2) + dm2
         endif
         coel = .true.
         if(mass(j2).gt.0.d0)then
            mass(j1) = 0.d0
            kstar(j1) = 15
         else
            kstar(j1) = kstar(j2)
            kstar(j2) = 15
         endif
         goto 135
      elseif(((ABS(ABS(2*kstar(j1)-11)-3).eq.2.or.kstar(j1).eq.9).
     &        and.(q(j1).gt.qc.or.radx(j1).le.radc(j1))).or.
     &        (kstar(j1).eq.2.and.q(j1).gt.qc).or.
     &        (kstar(j1).eq.4.and.q(j1).gt.qc))then
****
* The following allows us to merge HG donors as if 
* they were MS stars...
*
* Allow the stars to merge with the product in *1.
*
         if((kstar(j1).eq.2).and.(q(j1).gt.qc)) then
            m1ce = mass(j1)
            m2ce = mass(j2)
* We need the donor in the first place of the array
		helper(1) = j1
	      helper(2) = j2
            CALL mix(mass0,mass,aj,kstar,zpars,helper)
* we return to the usual way
            dm1 = m1ce - mass(j1)
            dm2 = mass(j2) - m2ce
*
* Next step should be made without changing the time.
*
            dtm = 0.d0
            epoch(1) = tphys - aj(1)
            coel = .true.
            goto 135
*
         endif
*
****
*
* Common-envelope evolution.
*
         m1ce = mass(j1)
         m2ce = mass(j2)
         CALL comenv(mass0(j1),mass(j1),massc(j1),aj(j1),jspin(j1),
     &               kstar(j1),mass0(j2),mass(j2),massc(j2),aj(j2),
     &               jspin(j2),kstar(j2),zpars,ecc,sep,jorb,coel)
*
         jp = MIN(80,jp + 1)
         bpp(jp,1) = tphys
         bpp(jp,2) = float(kstar(1))
         bpp(jp,3) = mass0(1)
         bpp(jp,4) = mass(1)
         if(kstar(1).eq.15) bpp(jp,4) = mass0(1)
         bpp(jp,5) = log10(lumin(1))
         bpp(jp,6) = log10(rad(1))
         teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad(1)**2.d0))**(1.d0/4.d0))
         bpp(jp,7) = log10(teff1)
         bpp(jp,8) = massc(1)
         bpp(jp,9) = radc(1)
         bpp(jp,10) = menv(1)
         bpp(jp,11) = renv(1)
         bpp(jp,12) = epoch(1)
         bpp(jp,13) = ospin(1)
         bpp(jp,14) = dmt(1) - dmr(1)
         bpp(jp,15) = rad(1)/rol(1)
         bpp(jp,16) = float(kstar(2))
         bpp(jp,17) = mass0(2)
         bpp(jp,18) = mass(2)
         if(kstar(2).eq.15) bpp(jp,18) = mass0(2)
         bpp(jp,19) = log10(lumin(2))
         bpp(jp,20) = log10(rad(2))
         teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                        (rad(2)**2.d0))**(1.d0/4.d0))
         bpp(jp,21) = log10(teff2)
         bpp(jp,22) = massc(2)
         bpp(jp,23) = radc(2)
         bpp(jp,24) = menv(2)
         bpp(jp,25) = renv(2)
         bpp(jp,26) = epoch(2)
         bpp(jp,27) = ospin(2)
         bpp(jp,28) = dmt(2) - dmr(2)
         bpp(jp,29) = rad(2)/rol(2)
         bpp(jp,30) = tb
         bpp(jp,31) = sep
         bpp(jp,32) = ecc
         bpp(jp,33) = 7.0
*
         epoch(j1) = tphys - aj(j1)
         if(coel)then
            com = .true.
            goto 135
         endif
         epoch(j2) = tphys - aj(j2)
         if(ecc.gt.1.d0)then
            if(kstar(1).ge.13)then
               rc = corerd(kstar(1),mass(1),mass(1),zpars(2))
               ospin(1) = jspin(1)/(k3*rc*rc*mass(1))
            endif
            if(kstar(2).ge.13)then
               rc = corerd(kstar(2),mass(2),mass(2),zpars(2))
               ospin(2) = jspin(2)/(k3*rc*rc*mass(2))
            endif
            goto 135
         endif
*
* Next step should be made without changing the time.
*
         dm1 = m1ce - mass(j1)
         dm2 = mass(j2) - m2ce
         dm22 = dm2
         dtm = 0.d0
*
* Reset orbital parameters as separation may have changed.
*
         tb = (sep/aursun)*SQRT(sep/(aursun*(mass(1)+mass(2))))
         oorb = twopi/tb
      elseif(kstar(j1).ge.10.and.kstar(j1).le.12.and.
     &       q(j1).gt.0.628d0)then
*
* Dynamic transfer from a white dwarf.  Secondary will have KW > 9.
*
         taum = SQRT(tkh(j1)*tdyn)
         dm1 = mass(j1)
         if(eddfac.lt.10.d0)then
            dm2 = MIN(dme*taum/tb,dm1)
            if(dm2.lt.dm1) supedd = .true. 
         else
            dm2 = dm1
         endif
         mass(j2) = mass(j2) + dm2
*
         if(kstar(j1).eq.10.and.kstar(j2).eq.10)then
*
* Assume the energy released by ignition of the triple-alpha reaction 
* is enough to destroy the star. 
*
            kstar(j2) = 15
            mass(j2) = 0.d0
         elseif(kstar(j1).eq.10.or.kstar(j2).eq.10)then
*
* Should be helium overflowing onto a CO or ONe core in which case the 
* helium swells up to form a giant envelope so a HeGB star is formed. 
* Allowance for the rare case of CO or ONe flowing onto He is made. 
*
            kst = 9
            if(kstar(j2).eq.10) massc(j2) = dm2
            CALL gntage(massc(j2),mass(j2),kst,zpars,mass0(j2),aj(j2))
            kstar(j2) = kst
            epoch(j2) = tphys - aj(j2)
         elseif(kstar(j2).le.12)then
            mass0(j2) = mass(j2)
            if(kstar(j1).eq.12.and.kstar(j2).eq.11)then
*
* Mixture of ONe and CO will result in an ONe product. 
*
               kstar(j2) = 12
            endif
         endif
         kstar(j1) = 15
         mass(j1) = 0.d0
*
* Might be a supernova that destroys the system.
*
         if(kstar(j2).le.11.and.mass(j2).gt.mch)then
            kstar(j2) = 15
            mass(j2) = 0.d0
         endif
         coel = .true.
         goto 135
      elseif(kstar(j1).eq.13)then
*
* Gamma ray burster?
*
         dm1 = mass(j1)
         mass(j1) = 0.d0
         kstar(j1) = 15
         dm2 = dm1
         mass(j2) = mass(j2) + dm2
         if(mass(j2).gt.mxns)then
           kstar(j2) = 14
         else
	       kstar(j2) = 13
         endif
         coel = .true.
         goto 135
      elseif(kstar(j1).eq.14)then
*
* Both stars are black holes.  Let them merge quietly.
*
         dm1 = mass(j1)
         mass(j1) = 0.d0
         kstar(j1) = 15
         dm2 = dm1
         mass(j2) = mass(j2) + dm2
         coel = .true.
         goto 135
      else
*
* Mass transfer in one Kepler orbit.
*
         dm1 = 3.0d-06*tb*(LOG(rad(j1)/rol(j1))**3)*
     &         MIN(mass(j1),5.d0)**2
         if(kstar(j1).eq.2)then
            mew = (mass(j1) - massc(j1))/mass(j1)
            dm1 = MAX(mew,0.01d0)*dm1
         elseif(kstar(j1).ge.10)then
*           dm1 = dm1*1.0d+03/MAX(rad(j1),1.0d-04)
            dm1 = dm1*1.0d+03*mass(j1)/MAX(rad(j1),1.0d-04)
         endif
         kst = kstar(j2)
*
* Possibly mass transfer needs to be reduced if primary is rotating 
* faster than the orbit (not currently implemented). 
*
*        spnfac = MIN(3.d0,MAX(ospin(j1)/oorb,1.d0))
*        dm1 = dm1/spnfac**2
*
* Limit mass transfer to the thermal rate for remaining giant-like stars
* and to the dynamical rate for all others.
*
         if(kstar(j1).ge.2.and.kstar(j1).le.9.and.kstar(j1).ne.7)then
***
* JH_temp ... this may be good for HG RLOF??
*           if(kstar(j1).eq.2)then
*              mew = rad(j1)/rol(j1) - 1.d0
*              mew = 2.d0*mew
*              dm1 = dm1*10.d0**mew
*           endif
***
            dm1 = MIN(dm1,mass(j1)*tb/tkh(j1))
         elseif(rad(j1).gt.10.d0*rol(j1).or.(kstar(j1).le.1.and.
     &          kstar(j2).le.1.and.q(j1).gt.qc))then
*
* Allow the stars to merge with the product in *1.
*
            m1ce = mass(j1)
            m2ce = mass(j2)
***
* Beacuse the collisional matrix is not symmetric 
		helper(1) = j1
		helper(2) = j2
            CALL mix(mass0,mass,aj,kstar,zpars,helper)
* we return to the usual way
*
***
            dm1 = m1ce - mass(j1)
            dm2 = mass(j2) - m2ce
*
* Next step should be made without changing the time.
*
            dtm = 0.d0
            epoch(1) = tphys - aj(1)
            coel = .true.
            goto 135
         else
            dm1 = MIN(dm1,mass(j1)*tb/tdyn)
         endif
*
* Calculate wind mass loss from the stars during one orbit.
*
         vorb2 = acc1*(mass(1)+mass(2))/sep
         ivsqm = 1.d0/SQRT(1.d0-ecc*ecc)
         do 14 , k = 1,2
            if(neta.gt.tiny)then
               rlperi = rol(k)*(1.d0-ecc)
               dmr(k) = mlwind(kstar(k),lumin(k),radx(k),
     &                         mass(k),massc(k),rlperi,z)
               vwind2 = 2.d0*beta*acc1*mass(k)/radx(k)
               omv2 = (1.d0 + vorb2/vwind2)**(3.d0/2.d0)
               dmt(3-k) = ivsqm*acc2*dmr(k)*((acc1*mass(3-k)/vwind2)**2)
     &                    /(2.d0*sep*sep*omv2)
               dmt(3-k) = MIN(dmt(3-k),dmr(k))
            else
               dmr(k) = 0.d0
               dmt(3-k) = 0.d0
            endif
*
 14      continue
*
         do 15 , k = 1,2
            dms(k) = (dmr(k)-dmt(k))*tb
 15      continue
*
* Increase time-scale to relative mass loss of 0.5% but not more than twice.
* KM is the number of orbits for the timestep.
*
         km = MIN(2.d0*km0,5.0d-03/
     &            MAX(ABS(dm1+dms(j1))/mass(j1),dms(j2)/mass(j2)))
         km0 = km
*
*       Modify time-step & mass loss terms by speed-up factor.
*
         dt = km*tb
         dtm = dt/1.0d+06
*
* Take the stellar evolution timestep into account but don't let it 
* be overly restrictive for long lived phases. 
*
         if(iter.le.1000) dtm = MIN(dtm,dtmi(1),dtmi(2)) 
         dtm = MIN(dtm,tsave-tphys)
         dt = dtm*1.0d+06
         km = dt/tb
*
* Decide between accreted mass by secondary and/or system mass loss.
*
         taum = mass(j2)/dm1*tb
         if(kstar(j2).le.2.or.kstar(j2).eq.4)then 
*
* Limit according to the thermal timescale of the secondary.
*
            dm2 = MIN(1.d0,10.d0*taum/tkh(j2))*dm1
         elseif(kstar(j2).ge.7.and.kstar(j2).le.9)then
*
* Naked helium star secondary swells up to a core helium burning star
* or SAGB star unless the primary is also a helium star.
*
            if(kstar(j1).ge.7)then
               dm2 = MIN(1.d0,10.d0*taum/tkh(j2))*dm1
            else
               dm2 = dm1
               dmchk = dm2 - 1.05d0*dms(j2)
               if(dmchk.gt.0.d0.and.dm2/mass(j2).gt.1.0d-04)then
                  kst = MIN(6,2*kstar(j2)-10)
                  if(kst.eq.4)then
                     aj(j2) = aj(j2)/tms(j2)
                     mcx = mass(j2)
                  else
                     mcx = massc(j2)
                  endif
                  mt2 = mass(j2) + km*(dm2 - dms(j2))
                  CALL gntage(mcx,mt2,kst,zpars,mass0(j2),aj(j2))
                  epoch(j2) = tphys + dtm - aj(j2)
*
                  jp = MIN(80,jp + 1)
                  bpp(jp,1) = tphys
                  bpp(jp,2) = float(kstar(j1))
                  bpp(jp,3) = mass0(1)
                  bpp(jp,4) = mass(j1)
                  bpp(jp,5) = log10(lumin(1))
                  bpp(jp,6) = log10(rad(1))
                  teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                                (rad(1)**2.d0))**(1.d0/4.d0))
                  bpp(jp,7) = log10(teff1)
                  bpp(jp,8) = massc(1)
                  bpp(jp,9) = radc(1)
                  bpp(jp,10) = menv(1)
                  bpp(jp,11) = renv(1)
                  bpp(jp,12) = epoch(1)
                  bpp(jp,13) = ospin(1)
                  bpp(jp,14) = dmt(1) - dmr(1)
                  bpp(jp,15) = rad(1)/rol(1)
                  bpp(jp,16) = float(kst)
                  bpp(jp,17) = mass0(2)
                  bpp(jp,18) = mt2
                  bpp(jp,19) = log10(lumin(2))
                  bpp(jp,20) = log10(rad(2))
                  teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                                 (rad(2)**2.d0))**(1.d0/4.d0))
                  bpp(jp,21) = log10(teff2)
                  bpp(jp,22) = massc(2)
                  bpp(jp,23) = radc(2)
                  bpp(jp,24) = menv(2)
                  bpp(jp,25) = renv(2)
                  bpp(jp,26) = epoch(2)
                  bpp(jp,27) = ospin(2)
                  bpp(jp,28) = dmt(2) - dmr(2)
                  bpp(jp,29) = rad(2)/rol(2)
                  bpp(jp,30) = tb
                  bpp(jp,31) = sep
                  bpp(jp,32) = ecc
                  bpp(jp,33) = 8.0
                  if(j1.eq.2)then
                     bpp(jp,4) = mt2
                     bpp(jp,18) = mass(j1)
                     bpp(jp,2) = float(kst)
                     bpp(jp,16) = float(kstar(j1))
                  endif
*
               endif
            endif            
         elseif(kstar(j1).le.6.and. 
     &           (kstar(j2).ge.10.and.kstar(j2).le.12))then
*
* White dwarf secondary.
*
            if(dm1/tb.lt.2.71d-07)then
               if(dm1/tb.lt.1.03d-07)then
*
* Accrete until a nova explosion blows away most of the accreted material.
*
                  novae = .true. 
                  dm2 = MIN(dm1,dme)
                  if(dm2.lt.dm1) supedd = .true. 
                  dm22 = epsnov*dm2
               else
*
* Steady burning at the surface
*
                  dm2 = dm1
               endif
            else
*
* Make a new giant envelope.
*
               dm2 = dm1
*
* Check for planets or low-mass WDs.
*
               if((kstar(j2).eq.10.and.mass(j2).lt.0.05d0).or.
     &            (kstar(j2).ge.11.and.mass(j2).lt.0.5d0))then
                  kst = kstar(j2)
               else
                  kst = MIN(6,3*kstar(j2)-27)
                  mt2 = mass(j2) + km*(dm2 - dms(j2))
                  CALL gntage(massc(j2),mt2,kst,zpars,mass0(j2),aj(j2))
                  epoch(j2) = tphys + dtm - aj(j2)
*
                  jp = MIN(80,jp + 1)
                  bpp(jp,1) = tphys
                  bpp(jp,2) = float(kstar(j1))
                  bpp(jp,3) = mass0(1)
                  bpp(jp,4) = mass(j1)
                  bpp(jp,5) = log10(lumin(1))
                  bpp(jp,6) = log10(rad(1))
                  teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                                 (rad(1)**2.d0))**(1.d0/4.d0))
                  bpp(jp,7) = log10(teff1)
                  bpp(jp,8) = massc(1)
                  bpp(jp,9) = radc(1)
                  bpp(jp,10) = menv(1)
                  bpp(jp,11) = renv(1)
                  bpp(jp,12) = epoch(1)
                  bpp(jp,13) = ospin(1)
                  bpp(jp,14) = dmt(1) - dmr(1)
                  bpp(jp,15) = rad(1)/rol(1)
                  bpp(jp,16) = float(kst)
                  bpp(jp,17) = mass0(2)
                  bpp(jp,18) = mt2
                  bpp(jp,19) = log10(lumin(2))
                  bpp(jp,20) = log10(rad(2))
                  teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                                 (rad(2)**2.d0))**(1.d0/4.d0))
                  bpp(jp,21) = log10(teff2)
                  bpp(jp,22) = massc(2)
                  bpp(jp,23) = radc(2)
                  bpp(jp,24) = menv(2)
                  bpp(jp,25) = renv(2)
                  bpp(jp,26) = epoch(2)
                  bpp(jp,27) = ospin(2)
                  bpp(jp,28) = dmt(2) - dmr(2)
                  bpp(jp,29) = rad(2)/rol(2)
                  bpp(jp,30) = tb
                  bpp(jp,31) = sep
                  bpp(jp,32) = ecc
                  bpp(jp,33) = 8.0
                  if(j1.eq.2)then
                     bpp(jp,4) = mt2
                     bpp(jp,18) = mass(j1)
                     bpp(jp,2) = float(kst)
                     bpp(jp,16) = float(kstar(j1))
                  endif
*
               endif
*
            endif
         elseif(kstar(j2).ge.10)then
*
* Impose the Eddington limit.
*
            dm2 = MIN(dm1,dme)
            if(dm2.lt.dm1) supedd = .true. 
*
         else
*
* We have a giant whose envelope can absorb any transferred material.
*
            dm2 = dm1
         endif
         if(.not.novae) dm22 = dm2
*
         if(kst.ge.10.and.kst.le.12)then
            mt2 = mass(j2) + km*(dm22 - dms(j2))
            if(kstar(j1).le.10.and.kst.eq.10.and.mt2.ge.0.7d0)then
*
* HeWD can only accrete helium-rich material up to a mass of 0.7 when
* it is destroyed in a possible Type 1a SN.
*
               mass(j1) = mass(j1) - km*(dm1 + dms(j1))
               mass(j2) = 0.d0
               kstar(j2) = 15
               goto 135
            elseif(kstar(j1).le.10.and.kst.ge.11)then
*
* CO and ONeWDs accrete helium-rich material until the accumulated 
* material exceeds a mass of 0.15 when it ignites. For a COWD with 
* mass less than 0.95 the system will be destroyed as an ELD in a 
* possible Type 1a SN. COWDs with mass greater than 0.95 and ONeWDs 
* will survive with all the material converted to ONe (JH 30/09/99). 
*
** Now changed to an ELD for all COWDs when 0.15 accreted (JH 11/01/00).  
*
               if((mt2-mass0(j2)).ge.0.15d0)then
                  if(kst.eq.11)then
                     mass(j1) = mass(j1) - km*(dm1 + dms(j1))
                     mass(j2) = 0.d0
                     kstar(j2) = 15
                     goto 135
                  endif
                  mass0(j2) = mt2
               endif
            else
               mass0(j2) = mt2
            endif
*
* If the Chandrasekhar limit is exceeded for a white dwarf then destroy
* the white dwarf in a supernova. If the WD is ONe then a neutron star
* will survive the supernova and we let HRDIAG take care of this when
* the stars are next updated.
*
            if(kst.eq.10.or.kst.eq.11)then
               if(mt2.ge.mch)then
                  dm1 = mch - mass(j2) + km*dms(j2)
                  mass(j1) = mass(j1) - dm1 - km*dms(j1)
                  mass(j2) = 0.d0
                  kstar(j2) = 15
                  goto 135
               endif
            endif
         endif
*
*       Modify mass loss terms by speed-up factor.
*
         dm1 = km*dm1
         dm2 = km*dm2
         dm22 = km*dm22
         dme = km*dme
*
* Calculate orbital angular momentum change due to system mass loss.
*
         djorb = ((dmr(1)+q(1)*dmt(1))*mass(2)*mass(2) +
     &            (dmr(2)+q(2)*dmt(2))*mass(1)*mass(1))/
     &           (mass(1)+mass(2))**2
         djorb = djorb*dt
*
* For super-Eddington mass transfer rates, for gamma = -2.0, 
* and for novae systems, assume that material is lost from  
* the system as if a wind from the secondary. 
* If gamma = -1.0 then assume the lost material carries with it 
* the specific angular momentum of the primary and for all 
* gamma > 0.0 assume that it takes away a fraction gamma of 
* the orbital angular momentum. 
*
         if(supedd.or.novae.or.gamma.lt.-1.5d0)then
            djorb = djorb + (dm1 - dm22)*mass(j1)*mass(j1)/
     &              (mass(1)+mass(2))**2
         elseif(gamma.ge.0.d0)then
            djorb = djorb + gamma*(dm1 - dm2)
         else
            djorb = djorb + (dm1 - dm2)*mass(j2)*mass(j2)/
     &              (mass(1)+mass(2))**2
         endif
*
         ecc2 = ecc*ecc
         omecc2 = 1.d0 - ecc2
         sqome2 = SQRT(omecc2)
*
         djorb = djorb*sep*sep*sqome2*oorb
         delet = 0.d0
*
* For very close systems include angular momentum loss mechanisms.
*
* Compute the merging time:
*	t_gw = 1/256 * c^5/G^3 * [a^4*(1 - e^2)^(7/2)]/[mass(1)*mass(2)*(m1 + m2)]
* where c = 1.3594037*10^7 [Rsun / yr] 
* 	  G = 3.9227785*10^8 [Rsun^3 / (Msun * yr^2)]
*
*         t_gw = 5.d0/256.d0*(1.3594037d0*10**7)**5/
*     &       (3.9227785d0*10**8)**3*
*     &	     sep**4*(1 - ecc2)**(7.d0/2.d0)/
*     &       (mass(1)*mass(2)*(mass(1)+mass(2)))/(10**6)
*
* ... but probably it's better to evolve the system in any case
       t_gw = 0.0
***
* GW are important only for compact objects
* 
	  if((kstar(1).ge.10 .and. kstar(2).ge.10).and.t_gw.le.tphysf)then
            djgr = 8.315d-10*mass(1)*mass(2)*(mass(1)+mass(2))/
     &             (sep*sep*sep*sep)
            f1 = (19.d0/6.d0) + (121.d0/96.d0)*ecc2
            sqome5 = sqome2**5
            delet1 = djgr*ecc*f1/sqome5
            djgr = djgr*jorb*(1.d0+0.875d0*ecc2)/sqome5
            djorb = djorb + djgr*dt
            delet = delet + delet1*dt
         endif
*
         do 602 , k = 1,2
*
            dms(k) = km*dms(k)
            if(kstar(k).lt.10) dms(k) = MIN(dms(k),mass(k) - massc(k))
*
* Calculate change in the intrinsic spin of the star.
*
            djspint(k) = (2.d0/3.d0)*(dmr(k)*radx(k)*radx(k)*ospin(k) -
     &                   xi*dmt(k)*radx(3-k)*radx(3-k)*ospin(3-k))
            djspint(k) = djspint(k)*dt
*
            if(mass(k).gt.0.35d0.and.kstar(k).lt.10)then
               djmb = 5.83d-16*menv(k)*(rad(k)*ospin(k))**3/mass(k)
               djspint(k) = djspint(k) + djmb*dt
            endif
*
 602     continue
*
* Adjust the spin angular momentum of each star owing to mass transfer 
* and conserve total angular momentum. 
*
         djt = dm1*radx(j1)*radx(j1)*ospin(j1)
         djspint(j1) = djspint(j1) + djt
         djorb = djorb - djt
         if(disk)then
*
* Alter spin of the degenerate secondary by assuming that material
* falls onto the star from the inner edge of a Keplerian accretion
* disk and that the system is in a steady state.
*
            djt = dm2*twopi*aursun*SQRT(aursun*mass(j2)*radx(j2)) 
            djspint(j2) = djspint(j2) - djt 
            djorb = djorb + djt
*
         else
*
* No accretion disk. 
* Calculate the angular momentum of the transferred material by 
* using the radius of the disk (see Ulrich & Burger) that would 
* have formed if allowed. 
*
            rdisk = 1.7d0*rmin
            djt = dm2*twopi*aursun*SQRT(aursun*mass(j2)*rdisk) 
            djspint(j2) = djspint(j2) - djt
            djorb = djorb + djt
*
         endif
         djtx(2) = djt
*
* Adjust the secondary spin if a nova eruption has occurred. 
*
         if(novae)then
            djt = (dm2 - dm22)*radx(j2)*radx(j2)*ospin(j2) 
            djspint(j2) = djspint(j2) + djt 
            djtx(2) = djtx(2) - djt
         endif
*
* Calculate circularization, orbital shrinkage and spin up.
*
         do 603 , k = 1,2
*
            dspint(k) = 0.d0
            if(((kstar(k).le.9.and.rad(k).ge.0.01d0*rol(k)).or.
     &         (kstar(k).ge.10.and.k.eq.j1)).and.tflag.gt.0)then
*
               raa2 = (radx(k)/sep)**2
               raa6 = raa2**3
*
               f5 = 1.d0+ecc2*(3.d0+ecc2*0.375d0)
               f4 = 1.d0+ecc2*(1.5d0+ecc2*0.125d0)
               f3 = 1.d0+ecc2*(3.75d0+ecc2*(1.875d0+ecc2*7.8125d-02))
               f2 = 1.d0+ecc2*(7.5d0+ecc2*(5.625d0+ecc2*0.3125d0))
               f1 = 1.d0+ecc2*(15.5d0+ecc2*(31.875d0+ecc2*(11.5625d0
     &                  +ecc2*0.390625d0)))
*
               if((kstar(k).eq.1.and.mass(k).ge.1.25d0).or.
     &            kstar(k).eq.4.or.kstar(k).eq.7)then
                  tc = 1.592d-09*(mass(k)**2.84d0)
                  f = 1.9782d+04*SQRT((mass(k)*radx(k)*radx(k))/sep**5)*
     &                tc*(1.d0+q(3-k))**(5.d0/6.d0)
                  tcqr = f*q(3-k)*raa6
                  rg2 = k2str(k)
               elseif(kstar(k).le.9)then
                  renv(k) = MIN(renv(k),radx(k)-radc(k))
                  renv(k) = MAX(renv(k),1.0d-10)
                  tc = mr23yr*(menv(k)*renv(k)*(radx(k)-0.5d0*renv(k))/
     &                 (3.d0*lumin(k)))**(1.d0/3.d0)
                  ttid = twopi/(1.0d-10 + ABS(oorb - ospin(k)))
                  f = MIN(1.d0,(ttid/(2.d0*tc)**2))
                  tcqr = 2.d0*f*q(3-k)*raa6*menv(k)/(21.d0*tc*mass(k))
                  rg2 = (k2str(k)*(mass(k)-massc(k)))/mass(k)
               else
                  f = 7.33d-09*(lumin(k)/mass(k))**(5.d0/7.d0)
                  tcqr = f*q(3-k)*q(3-k)*raa2*raa2/(1.d0+q(3-k))
                  rg2 = k3
               endif
               sqome3 = sqome2**3
               delet1 = 27.d0*tcqr*(1.d0+q(3-k))*raa2*(ecc/sqome2**13)*
     &                  (f3 - (11.d0/18.d0)*sqome3*f4*ospin(k)/oorb)
               tcirc = ecc/(ABS(delet1) + 1.0d-20)
               delet = delet + delet1*dt
               dspint(k) = (3.d0*q(3-k)*tcqr/(rg2*omecc2**6))*
     &                     (f2*oorb - sqome3*f5*ospin(k))
               eqspin = oorb*f2/(sqome3*f5)
               if(dt.gt.0.d0)then
                  if(dspint(k).ge.0.d0)then
                     dspint(k) = MIN(dt*dspint(k),eqspin-ospin(k))/dt
                  else
                     dspint(k) = MAX(dt*dspint(k),eqspin-ospin(k))/dt
                  endif
               endif
               djt = (k2str(k)*(mass(k)-massc(k))*radx(k)*radx(k) +
     &                k3*massc(k)*radc(k)*radc(k))*dspint(k)
               djorb = djorb + djt*dt
               djspint(k) = djspint(k) - djt*dt
*
            endif
*
            jspin(k) = MAX(1.0d-10,jspin(k) - djspint(k))
*
* Ensure that the star does not spin up beyond break-up, and transfer
* the excess angular momentum back to the orbit.
*
            ospbru = twopi*SQRT(mass(k)*aursun**3/radx(k)**3)
            jspbru = (k2str(k)*(mass(k)-massc(k))*radx(k)*radx(k) +
     &                k3*massc(k)*radc(k)*radc(k))*ospbru
            if(jspin(k).gt.jspbru)then
               mew = 1.d0
               if(djtx(2).gt.0.d0)then
                  mew = MIN(mew,(jspin(k) - jspbru)/djtx(2))
               endif
               djorb = djorb - (jspin(k) - jspbru)
               jspin(k) = jspbru
* If excess material should not be accreted, activate next line.
*              dm22 = (1.d0 - mew)*dm22
            endif
*
 603     continue
*
* Update the masses.
*
         kstar(j2) = kst
         mass(j1) = mass(j1) - dm1 - dms(j1)
         if(kstar(j1).le.1.or.kstar(j1).eq.7) mass0(j1) = mass(j1)
         mass(j2) = mass(j2) + dm22 - dms(j2)
         if(kstar(j2).le.1.or.kstar(j2).eq.7) mass0(j2) = mass(j2)
*
* For a HG star check if the initial mass can be reduced. 
*
         if(kstar(j1).eq.2.and.mass0(j1).le.zpars(3))then
            m0 = mass0(j1)
            mass0(j1) = mass(j1)
            CALL star(kstar(j1),mass0(j1),mass(j1),tmsnew,tn,tscls,
     &                lums,GB,zpars)
            if(GB(9).lt.massc(j1))then
               mass0(j1) = m0
            endif
         endif
         if(kstar(j2).eq.2.and.mass0(j2).le.zpars(3))then
            m0 = mass0(j2)
            mass0(j2) = mass(j2)
            CALL star(kstar(j2),mass0(j2),mass(j2),tmsnew,tn,tscls,
     &                lums,GB,zpars)
            if(GB(9).lt.massc(j2))then
               mass0(j2) = m0
            endif
         endif
*
         ecc = ecc - delet
         ecc = MAX(ecc,0.d0)
         if(ecc.lt.1.0d-10) ecc = 0.d0
*
         if(ecc.ge.1.d0) goto 135
*
* Ensure that Jorb does not become negative which could happen if the 
* primary overfills its Roche lobe initially. In this case we simply 
* allow contact to occur.
*
         jorb = MAX(1.d0,jorb - djorb)
         sep = (mass(1) + mass(2))*jorb*jorb/
     &         ((mass(1)*mass(2)*twopi)**2*aursun**3*(1.d0-ecc*ecc))
         tb = (sep/aursun)*SQRT(sep/(aursun*(mass(1)+mass(2))))
         oorb = twopi/tb
*
      endif
*
* Always rejuvenate the secondary and age the primary if they are on
* the main sequence.
*
      if(kstar(j1).le.2.or.kstar(j1).eq.7)then
         CALL star(kstar(j1),mass0(j1),mass(j1),tmsnew,tn,tscls,
     &             lums,GB,zpars)
         if(kstar(j1).eq.2)then
            aj(j1) = tmsnew + (tscls(1) - tmsnew)*(aj(j1)-tms(j1))/
     &                        (tbgb(j1) - tms(j1))
         else
            aj(j1) = tmsnew/tms(j1)*aj(j1)
         endif
         epoch(j1) = tphys - aj(j1)
      endif
*
      if(kstar(j2).le.2.or.kstar(j2).eq.7)then
         CALL star(kstar(j2),mass0(j2),mass(j2),tmsnew,tn,tscls,
     &             lums,GB,zpars)
         if(kstar(j2).eq.2)then
            aj(j2) = tmsnew + (tscls(1) - tmsnew)*(aj(j2)-tms(j2))/
     &                        (tbgb(j2) - tms(j2))
         elseif((mass(j2).lt.0.35d0.or.mass(j2).gt.1.25d0).
     &           and.kstar(j2).ne.7)then
            aj(j2) = tmsnew/tms(j2)*aj(j2)*(mass(j2) - dm22)/mass(j2)
         else
            aj(j2) = tmsnew/tms(j2)*aj(j2)
         endif
         epoch(j2) = tphys - aj(j2)
      endif
*
* Obtain the stellar parameters for the next step.
*
      tphys = tphys + dtm
      do 90 , k = 1,2
         age = tphys - epoch(k)
         m0 = mass0(k)
         mt = mass(k)
         mc = massc(k)
*
* Masses over 150Msun should probably not be trusted in the
* evolution formulae.
*
         if(mt.gt.150.d0)then
            WRITE(99,*)' MASS EXCEEDED in evolv3.f',mass1i,mass2i,
     &                  tbi,ecci,mt
            goto 140
         endif
         kw = kstar(k)
         CALL star(kw,m0,mt,tm,tn,tscls,lums,GB,zpars)
         CALL hrdiag(m0,age,mt,tm,tn,tscls,lums,GB,zpars,
     &               rm,lum,kw,mc,rc,me,re,k2)
*
* Check for a supernova and correct the semi-major axis if so.
*
         if(kw.ne.kstar(k).and.kstar(k).le.12.and.
     &      (kw.eq.13.or.kw.eq.14))then
            dms(k) = mass(k) - mt
            CALL kick(kw,mass(k),mt,mass(3-k),ecc,sep,jorb,vs)
            if(ecc.gt.1.d0)then
               kstar(k) = kw
               mass(k) = mt
               epoch(k) = tphys - age
               goto 135
            endif
            tb = (sep/aursun)*SQRT(sep/(aursun*(mt+mass(3-k))))
            oorb = twopi/tb
         endif
         if(kw.ne.kstar(k))then
            change = .true.
            if((kw.eq.13.or.kw.eq.14).and.kstar(k).le.12)then
               snova = .true.
            endif
            mass(k) = mt
            if(kw.eq.15)then
               kstar(k) = kw
               goto 135
            endif
            mass0(k) = m0
            epoch(k) = tphys - age
         endif
*
*     Determine stellar evolution timescale for nuclear burning types.
*
         if(kw.le.9)then
            CALL deltat(kw,age,tm,tn,tscls,dt,dtr)
            dtmi(k) = MIN(dt,dtr)
*           dtmi(k) = dtr
            dtmi(k) = MAX(1.0d-07,dtmi(k))
         else
            dtmi(k) = 1.0d+10
         endif
*        dtmi(k) = MAX((tn-age),1.0d-07)
*
* Save relevent solar quantities.
*
         aj(k) = age
         kstar(k) = kw
         rad(k) = rm
         radx(k) = rm
         lumin(k) = lum
         massc(k) = mc
         radc(k) = rc
         menv(k) = me
         renv(k) = re
         k2str(k) = k2
         tms(k) = tm
         tbgb(k) = tscls(1)
*
* Check for blue straggler formation. 
*
         if(kw.le.1.and.tm.lt.tphys.and..not.bss)then
            bss = .true.
            jp = MIN(80,jp + 1)
            bpp(jp,1) = tphys
            bpp(jp,2) = float(kstar(1))
            bpp(jp,3) = mass0(1)
            bpp(jp,4) = mass(1)
            bpp(jp,5) = log10(lumin(1))
            bpp(jp,6) = log10(rad(1))
            teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                           (rad(1)**2.d0))**(1.d0/4.d0))
            bpp(jp,7) = log10(teff1)
            bpp(jp,8) = massc(1)
            bpp(jp,9) = radc(1)
            bpp(jp,10) = menv(1)
            bpp(jp,11) = renv(1)
            bpp(jp,12) = epoch(1)
            bpp(jp,13) = ospin(1)
            bpp(jp,14) = dmt(1) - dmr(1)
            bpp(jp,15) = rad(1)/rol(1)
            bpp(jp,16) = float(kstar(2))
            bpp(jp,17) = mass0(2)
            bpp(jp,18) = mass(2)
            bpp(jp,19) = log10(lumin(2))
            bpp(jp,20) = log10(rad(2))
            teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                           (rad(2)**2.d0))**(1.d0/4.d0))
            bpp(jp,21) = log10(teff2)
            bpp(jp,22) = massc(2)
            bpp(jp,23) = radc(2)
            bpp(jp,24) = menv(2)
            bpp(jp,25) = renv(2)
            bpp(jp,26) = epoch(2)
            bpp(jp,27) = ospin(2)
            bpp(jp,28) = dmt(2) - dmr(2)
            bpp(jp,29) = rad(2)/rol(2)
            bpp(jp,30) = tb
            bpp(jp,31) = sep
            bpp(jp,32) = ecc
            bpp(jp,33) = 14.0
         endif
*
 90   continue
*
      do 100 , k = 1,2
         q(k) = mass(k)/mass(3-k)
         rol(k) = rl(q(k))*sep
 100  continue
      if(rad(j1).gt.rol(j1)) radx(j1) = MAX(radc(j1),rol(j1))
      do 110 , k = 1,2
         ospin(k) = jspin(k)/(k2str(k)*(mass(k)-massc(k))*radx(k)*
     &              radx(k) + k3*massc(k)*radc(k)*radc(k))
 110  continue
*
      if((isave.and.tphys.ge.tsave).or.iplot)then
         ip = ip + 1
         bcm(ip,1) = tphys
         bcm(ip,2) = float(kstar(1))
         bcm(ip,3) = mass0(1)
         bcm(ip,4) = mass(1)
         bcm(ip,5) = log10(lumin(1))
         bcm(ip,6) = log10(rad(1))
         teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                    (rad(1)**2.d0))**(1.d0/4.d0))
         bcm(ip,7) = log10(teff1)
         bcm(ip,8) = massc(1)
         bcm(ip,9) = radc(1)
         bcm(ip,10) = menv(1)
         bcm(ip,11) = renv(1)
         bcm(ip,12) = epoch(1)
         bcm(ip,13) = ospin(1)
         bcm(ip,15) = rad(1)/rol(1)
         bcm(ip,16) = float(kstar(2))
         bcm(ip,17) = mass0(2)
         bcm(ip,18) = mass(2)
         bcm(ip,19) = log10(lumin(2))
         bcm(ip,20) = log10(rad(2))
         teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                    (rad(2)**2.d0))**(1.d0/4.d0))
         bcm(ip,21) = log10(teff2)
         bcm(ip,22) = massc(2)
         bcm(ip,23) = radc(2)
         bcm(ip,24) = menv(2)
         bcm(ip,25) = renv(2)
         bcm(ip,26) = epoch(2)
         bcm(ip,27) = ospin(2)
         bcm(ip,29) = rad(2)/rol(2)
         bcm(ip,30) = tb
         bcm(ip,31) = sep
         bcm(ip,32) = ecc
         dt = MAX(dtm,1.0d-12)*1.0d+06
         if(j1.eq.1)then
            bcm(ip,14) = (-1.0*dm1 - dms(1))/dt
            bcm(ip,28) = (dm2 - dms(2))/dt
         else
            bcm(ip,14) = (dm2 - dms(1))/dt
            bcm(ip,28) = (-1.0*dm1 - dms(2))/dt
         endif
         if(isave) tsave = tsave + dtp
      endif
*
      if(tphys.ge.tphysf) goto 140
*
      if(change)then
         change = .false.
         jp = MIN(80,jp + 1)
         bpp(jp,1) = tphys
         bpp(jp,2) = float(kstar(1))
         bpp(jp,3) = mass0(1)
         bpp(jp,4) = mass(1)
         bpp(jp,5) = log10(lumin(1))
         bpp(jp,6) = log10(rad(1))
         teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                        (rad(1)**2.d0))**(1.d0/4.d0))
         bpp(jp,7) = log10(teff1)
         bpp(jp,8) = massc(1)
         bpp(jp,9) = radc(1)
         bpp(jp,10) = menv(1)
         bpp(jp,11) = renv(1)
         bpp(jp,12) = epoch(1)
         bpp(jp,13) = ospin(1)
         bpp(jp,14) = dmt(1) - dmr(1)
         bpp(jp,15) = rad(1)/rol(1)
         bpp(jp,16) = float(kstar(2))
         bpp(jp,17) = mass0(2)
         bpp(jp,18) = mass(2)
         bpp(jp,19) = log10(lumin(2))
         bpp(jp,20) = log10(rad(2))
         teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                        (rad(2)**2.d0))**(1.d0/4.d0))
         bpp(jp,21) = log10(teff2)
         bpp(jp,22) = massc(2)
         bpp(jp,23) = radc(2)
         bpp(jp,24) = menv(2)
         bpp(jp,25) = renv(2)
         bpp(jp,26) = epoch(2)
         bpp(jp,27) = ospin(2)
         bpp(jp,28) = dmt(2) - dmr(2)
         bpp(jp,29) = rad(2)/rol(2)
         bpp(jp,30) = tb
         bpp(jp,31) = sep
         bpp(jp,32) = ecc
         bpp(jp,33) = 2.0
      endif
*
* Test whether the primary still fills its Roche lobe.
*
      if(rad(j1).gt.rol(j1).and..not.snova)then
*
* Test for a contact system
*
         if(rad(j2).gt.rol(j2)) goto 130
         iter = iter + 1
         goto 8
      else
         jp = MIN(80,jp + 1)
         bpp(jp,1) = tphys
         bpp(jp,2) = float(kstar(1))
         bpp(jp,3) = mass0(1)
         bpp(jp,4) = mass(1)
         bpp(jp,5) = log10(lumin(1))
         bpp(jp,6) = log10(rad(1))
         teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                        (rad(1)**2.d0))**(1.d0/4.d0))
         bpp(jp,7) = log10(teff1)
         bpp(jp,8) = massc(1)
         bpp(jp,9) = radc(1)
         bpp(jp,10) = menv(1)
         bpp(jp,11) = renv(1)
         bpp(jp,12) = epoch(1)
         bpp(jp,13) = ospin(1)
         bpp(jp,14) = dmt(1) - dmr(1)
         bpp(jp,15) = rad(1)/rol(1)
         bpp(jp,16) = float(kstar(2))
         bpp(jp,17) = mass0(2)
         bpp(jp,18) = mass(2)
         bpp(jp,19) = log10(lumin(2))
         bpp(jp,20) = log10(rad(2))
         teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                        (rad(2)**2.d0))**(1.d0/4.d0))
         bpp(jp,21) = log10(teff2)
         bpp(jp,22) = massc(2)
         bpp(jp,23) = radc(2)
         bpp(jp,24) = menv(2)
         bpp(jp,25) = renv(2)
         bpp(jp,26) = epoch(2)
         bpp(jp,27) = ospin(2)
         bpp(jp,28) = dmt(2) - dmr(2)
         bpp(jp,29) = rad(2)/rol(2)
         bpp(jp,30) = tb
         bpp(jp,31) = sep
         bpp(jp,32) = ecc
         bpp(jp,33) = 4.0
         dtm = 0.d0
         goto 4
      endif

*
 130  continue
*
* Contact system.
*
      coel = .true.
*
* If *1 or *2 is giant-like this will be common-envelope evolution.
*
      m1ce = mass(j1)
      m2ce = mass(j2)
      rrl1 = MIN(999.999d0,rad(1)/rol(1))
      rrl2 = MIN(999.999d0,rad(2)/rol(2))
*
      jp = MIN(80,jp + 1)
      bpp(jp,1) = tphys
      bpp(jp,2) = float(kstar(1))
      bpp(jp,3) = mass0(1)
      bpp(jp,4) = mass(1)
      bpp(jp,5) = log10(lumin(1))
      bpp(jp,6) = log10(rad(1))
      teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                    (rad(1)**2.d0))**(1.d0/4.d0))
      bpp(jp,7) = log10(teff1)
      bpp(jp,8) = massc(1)
      bpp(jp,9) = radc(1)
      bpp(jp,10) = menv(1)
      bpp(jp,11) = renv(1)
      bpp(jp,12) = epoch(1)
      bpp(jp,13) = ospin(1)
      bpp(jp,14) = dmt(1) - dmr(1)
      bpp(jp,15) = rrl1
      bpp(jp,16) = float(kstar(2))
      bpp(jp,17) = mass0(2)
      bpp(jp,18) = mass(2)
      bpp(jp,19) = log10(lumin(2))
      bpp(jp,20) = log10(rad(2))
      teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                    (rad(2)**2.d0))**(1.d0/4.d0))
      bpp(jp,21) = log10(teff2)
      bpp(jp,22) = massc(2)
      bpp(jp,23) = radc(2)
      bpp(jp,24) = menv(2)
      bpp(jp,25) = renv(2)
      bpp(jp,26) = epoch(2)
      bpp(jp,27) = ospin(2)
      bpp(jp,28) = dmt(2) - dmr(2)
      bpp(jp,29) = rrl2
      bpp(jp,30) = tb
      bpp(jp,31) = sep
      bpp(jp,32) = ecc
      bpp(jp,33) = 5.0
*
***
* HG donors behave like MS stars
*
      if(kstar(j1).ge.3.and.kstar(j1).le.9.and.kstar(j1).ne.7)then
         CALL comenv(mass0(j1),mass(j1),massc(j1),aj(j1),jspin(j1),
     &               kstar(j1),mass0(j2),mass(j2),massc(j2),aj(j2),
     &               jspin(j2),kstar(j2),zpars,ecc,sep,jorb,coel)
         com = .true.
      elseif(kstar(j2).ge.3.and.kstar(j2).le.9.and.kstar(j2).ne.7)then
         CALL comenv(mass0(j2),mass(j2),massc(j2),aj(j2),jspin(j2),
     &               kstar(j2),mass0(j1),mass(j1),massc(j1),aj(j1),
     &               jspin(j1),kstar(j1),zpars,ecc,sep,jorb,coel)
         com = .true.
      else
*
* beacuse the collisional matrix is not symmetric 
		helper(1) = j1
		helper(2) = j2
            CALL mix(mass0,mass,aj,kstar,zpars,helper)
* we return to the usual way
*
***
      endif
      if(com)then
         jp = MIN(80,jp + 1)
         bpp(jp,1) = tphys
         bpp(jp,2) = float(kstar(1))
         bpp(jp,3) = mass0(1)
         bpp(jp,4) = mass(1)
         if(kstar(1).eq.15) bpp(jp,4) = mass0(1)
         bpp(jp,5) = log10(lumin(1))
         bpp(jp,6) = log10(rad(1))
         teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                        (rad(1)**2.d0))**(1.d0/4.d0))
         bpp(jp,7) = log10(teff1)
         bpp(jp,8) = massc(1)
         bpp(jp,9) = radc(1)
         bpp(jp,10) = menv(1)
         bpp(jp,11) = renv(1)
         bpp(jp,12) = epoch(1)
         bpp(jp,13) = ospin(1)
         bpp(jp,14) = dmt(1) - dmr(1)
         rrl1 = MIN(rrl1,0.99d0)
         bpp(jp,15) = rrl1
         bpp(jp,16) = float(kstar(2))
         bpp(jp,17) = mass0(2)
         bpp(jp,18) = mass(2)
         if(kstar(2).eq.15) bpp(jp,18) = mass0(2)
         bpp(jp,19) = log10(lumin(2))
         bpp(jp,20) = log10(rad(2))
         teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                        (rad(2)**2.d0))**(1.d0/4.d0))
         bpp(jp,21) = log10(teff2)
         bpp(jp,22) = massc(2)
         bpp(jp,23) = radc(2)
         bpp(jp,24) = menv(2)
         bpp(jp,25) = renv(2)
         bpp(jp,26) = epoch(2)
         bpp(jp,27) = ospin(2)
         bpp(jp,28) = dmt(2) - dmr(2)
         rrl2 = MIN(rrl2,0.99d0)
         bpp(jp,29) = rrl2
         bpp(jp,30) = tb
         bpp(jp,31) = sep
         bpp(jp,32) = ecc
         bpp(jp,33) = 7.0
      endif
      epoch(1) = tphys - aj(1)
      epoch(2) = tphys - aj(2)
      if(.not.coel)then
*
* Next step should be made without changing the time.
*
         if(ecc.gt.1.d0)then
            if(kstar(1).ge.13)then
               rc = corerd(kstar(1),mass(1),mass(1),zpars(2))
               ospin(1) = jspin(1)/(k3*rc*rc*mass(1))
            endif
            if(kstar(2).ge.13)then
               rc = corerd(kstar(2),mass(2),mass(2),zpars(2))
               ospin(2) = jspin(2)/(k3*rc*rc*mass(2))
            endif
            goto 135
         endif
         dtm = 0.d0
*
* Reset orbital parameters as separation may have changed.
*
         tb = (sep/aursun)*SQRT(sep/(aursun*(mass(1)+mass(2))))
         oorb = twopi/tb
         goto 4
      endif
*
 135  continue
*
      sgl = .true.
      if(kstar(1).ne.15.or.kstar(2).ne.15)then
         if(com)then
            com = .false.
         else
            jp = MIN(80,jp + 1)
            bpp(jp,1) = tphys
            bpp(jp,2) = float(kstar(1))
            bpp(jp,3) = mass0(1)
            bpp(jp,4) = mass(1)
            if(kstar(1).eq.15) bpp(jp,4) = mass0(1)
            bpp(jp,5) = log10(lumin(1))
            bpp(jp,6) = log10(rad(1))
            teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                           (rad(1)**2.d0))**(1.d0/4.d0))
            bpp(jp,7) = log10(teff1)
            bpp(jp,8) = massc(1)
            bpp(jp,9) = radc(1)
            bpp(jp,10) = menv(1)
            bpp(jp,11) = renv(1)
            bpp(jp,12) = epoch(1)
            bpp(jp,13) = ospin(1)
            bpp(jp,14) = dmt(1) - dmr(1)
            bpp(jp,15) = zero
            bpp(jp,16) = float(kstar(2))
            bpp(jp,17) = mass0(2)
            bpp(jp,18) = mass(2)
            if(kstar(2).eq.15) bpp(jp,18) = mass0(2)
            bpp(jp,19) = log10(lumin(2))
            bpp(jp,20) = log10(rad(2))
            teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                           (rad(2)**2.d0))**(1.d0/4.d0))
            bpp(jp,21) = log10(teff2)
            bpp(jp,22) = massc(2)
            bpp(jp,23) = radc(2)
            bpp(jp,24) = menv(2)
            bpp(jp,25) = renv(2)
            bpp(jp,26) = epoch(2)
            bpp(jp,27) = ospin(2)
            bpp(jp,28) = dmt(2) - dmr(2)
            bpp(jp,29) = ngtv
            bpp(jp,30) = tb
            bpp(jp,31) = zero
            bpp(jp,32) = zero
            if(coel)then
               bpp(jp,33) = 6.0
            elseif(ecc.gt.1.d0)then
*
* Binary dissolved by a supernova or tides.
*
               bpp(jp,31) = sep
               bpp(jp,32) = ecc
               bpp(jp,29) = ngtv2
               bpp(jp,33) = 11.0
            else
               bpp(jp,33) = 9.0
            endif
         endif
         if(kstar(2).eq.15)then
            kmax = 1
            rol(2) = -1.d0*rad(2)
            dtmi(2) = tphysf
         elseif(kstar(1).eq.15)then
            kmin = 2
            rol(1) = -1.d0*rad(1)
            dtmi(1) = tphysf
         endif
         ecc = -1.d0
         sep = 0.d0
         dtm = 0.d0
         coel = .false.
         goto 4
      endif
*
 140  continue
*
      if(com)then
         com = .false.
      else
         jp = MIN(80,jp + 1)
         bpp(jp,1) = tphys
         bpp(jp,2) = float(kstar(1))
         bpp(jp,3) = mass0(1)
         bpp(jp,4) = mass(1)
         if(kstar(1).eq.15.and.bpp(jp-1,2).lt.15.0)then
            bpp(jp,4) = mass0(1)
         endif
         bpp(jp,5) = log10(lumin(1))
         bpp(jp,6) = log10(rad(1))
         teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                        (rad(1)**2.d0))**(1.d0/4.d0))
         bpp(jp,7) = log10(teff1)
         bpp(jp,8) = massc(1)
         bpp(jp,9) = radc(1)
         bpp(jp,10) = menv(1)
         bpp(jp,11) = renv(1)
         bpp(jp,12) = epoch(1)
         bpp(jp,13) = ospin(1)
         bpp(jp,14) = dmt(1) - dmr(1)
         bpp(jp,15) = zero
         bpp(jp,16) = float(kstar(2))
         bpp(jp,17) = mass0(2)
         bpp(jp,18) = mass(2)
         if(kstar(2).eq.15.and.bpp(jp-1,16).lt.15.0)then
            bpp(jp,18) = mass0(2)
         endif
         bpp(jp,19) = log10(lumin(2))
         bpp(jp,20) = log10(rad(2))
         teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                        (rad(2)**2.d0))**(1.d0/4.d0))
         bpp(jp,21) = log10(teff2)
         bpp(jp,22) = massc(2)
         bpp(jp,23) = radc(2)
         bpp(jp,24) = menv(2)
         bpp(jp,25) = renv(2)
         bpp(jp,26) = epoch(2)
         bpp(jp,27) = ospin(2)
         bpp(jp,28) = dmt(2) - dmr(2)
         bpp(jp,30) = tb
         bpp(jp,31) = zero
         bpp(jp,32) = zero
         if(coel)then
            bpp(jp,29) = ngtv
            bpp(jp,33) = 6.0
         elseif(kstar(1).eq.15.and.kstar(2).eq.15)then
*
* Cases of accretion induced supernova or single star supernova.
* No remnant is left in either case.
*
            bpp(jp,29) = ngtv2
            bpp(jp,33) = 9.0
         else
            bpp(jp,31) = sep
            bpp(jp,32) = ecc
            bpp(jp,15) = rad(1)/rol(1)
            bpp(jp,29) = rad(2)/rol(2)
            bpp(jp,33) = 10.0
         endif
      endif
*
      if((isave.and.tphys.ge.tsave).or.iplot)then
         ip = ip + 1
         bcm(ip,1) = tphys
         bcm(ip,2) = float(kstar(1))
         bcm(ip,3) = mass0(1)
         bcm(ip,4) = mass(1)
         bcm(ip,5) = log10(lumin(1))
         bcm(ip,6) = log10(rad(1))
         teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                    (rad(1)**2.d0))**(1.d0/4.d0))
         bcm(ip,7) = log10(teff1)
         bcm(ip,8) = massc(1)
         bcm(ip,9) = radc(1)
         bcm(ip,10) = menv(1)
         bcm(ip,11) = renv(1)
         bcm(ip,12) = epoch(1)
         bcm(ip,13) = ospin(1)
         bcm(ip,15) = rad(1)/rol(1)
         bcm(ip,16) = float(kstar(2))
         bcm(ip,17) = mass0(2)
         bcm(ip,18) = mass(2)
         bcm(ip,19) = log10(lumin(2))
         bcm(ip,20) = log10(rad(2))
         teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                    (rad(2)**2.d0))**(1.d0/4.d0))
         bcm(ip,21) = log10(teff2)
         bcm(ip,22) = massc(2)
         bcm(ip,23) = radc(2)
         bcm(ip,24) = menv(2)
         bcm(ip,25) = renv(2)
         bcm(ip,26) = epoch(2)
         bcm(ip,27) = ospin(2)
         bcm(ip,29) = rad(2)/rol(2)
         bcm(ip,30) = tb
         bcm(ip,31) = sep
         bcm(ip,32) = ecc
         dt = MAX(dtm,1.0d-12)*1.0d+06
         if(j1.eq.1)then
            bcm(ip,14) = (-1.0*dm1 - dms(1))/dt
            bcm(ip,28) = (dm2 - dms(2))/dt
         else
            bcm(ip,14) = (dm2 - dms(1))/dt
            bcm(ip,28) = (-1.0*dm1 - dms(2))/dt
         endif
         if(isave) tsave = tsave + dtp
         if(tphysf.le.0.d0)then
            ip = ip + 1
            do 145 , k = 1,32
               bcm(ip,k) = bcm(ip-1,k)
 145        continue
         endif
      endif
*
      tphysf = tphys
      if(sgl)then
         if(ecc.ge.0.d0.and.ecc.le.1.d0) ecc = -1.d0
         tb = -1.d0
      endif
      tb = tb*yeardy
      if(jp.ge.80)then
         WRITE(99,*)' EVOLV3 ARRAY ERROR ',mass1i,mass2i,tbi,ecci
         WRITE(*,*)' STOP: EVOLV3 ARRAY ERROR '
         CALL exit(0)
         STOP
      elseif(jp.ge.60)then
         WRITE(99,*)' EVOLV3 ARRAY WARNING ',mass1i,mass2i,tbi,ecci,jp
      endif
      bcm(ip+1,1) = -1.0
      bpp(jp+1,1) = -1.0
*
      RETURN
      END
***

***
      REAL FUNCTION ran3(IDUM)
*
* Random number generator from Numerical Recipes, Press et al. pg 272.
*
      IMPLICIT NONE
      INTEGER j,k,im1,im2,imm1,ia1,ia2,iq1,iq2,ir1,ir2,ntab,ndiv
      PARAMETER(im1=2147483563,im2=2147483399,ia1=40014,ia2=40692)
      PARAMETER(iq1=53668,iq2=52774,ir1=12211,ir2=3791,ntab=32)
      INTEGER idum
      INTEGER idum2,iy,ir(ntab),counter_ran3
      COMMON /RAND3/ idum2,iy,ir,counter_ran3
      DATA idum2/123456789/, iy/0/, ir/ntab*0/
      REAL am
*
* Helpfull counter
      counter_ran3 = counter_ran3 + 1
*
      am = 1.0/float(im1)
      imm1 = im1 - 1
      ndiv = 1 + imm1/ntab
*
      if(idum.le.0)then
         idum = MAX(-idum,1)
         idum2 = idum
         do 11 , j = ntab+8,1,-1
            k = idum/iq1
            idum = ia1*(idum-k*iq1)-k*ir1
            if(idum.lt.0) idum = idum + im1
            if(j.le.ntab) ir(j) = idum
 11      continue
         iy = ir(1)
      endif
      k = idum/iq1
      idum = ia1*(idum-k*iq1)-k*ir1
      if(idum.lt.0) idum = idum + im1
      k = idum2/iq2
      idum2 = ia2*(idum2-k*iq2)-k*ir2
      if(idum2.lt.0) idum2 = idum2 + im2
      j = 1 + iy/ndiv
      iy = ir(j) - idum2
      ir(j) = idum
      if(iy.lt.1) iy = iy + imm1
      ran3 = am*iy
*
      RETURN
      END
***

***
      real*8 FUNCTION fallback(sne,mc,mt)
*
*     Author : N. Giacobbo
*     Date :   25th March 2017
*
*     Fallback of matter after the SNe. 
*     Ref: Fryer et al. 2012 and Spera et al. 2015
*     --------------------------------------------------
*
*
      implicit none
      real*8 mt,mc
      real*8 mproto,alpha_R,beta_R,alpha_D,beta_D
      integer sne

      if(sne.eq.1)then
* StarTrack      
         if(mc.lt.5.d0)then
	    fallback = 0.d0
	 elseif(5.d0.le.mc .and. mc.lt.7.6d0)then
	    fallback = 0.378d0*mc - 1.889d0
	 elseif(7.6d0.le.mc)then
	    fallback = 1.d0
	 endif
* 
      elseif(sne.eq.2)then
* Rapid
	 mproto = 1.d0
	 alpha_R = 0.25d0 - 1.275d0/(mt - mproto)
	 beta_R = 1.d0 - 11.d0*alpha_R
*	 
	 if(mc.lt.2.5d0)then
	    fallback = 0.2d0/(mt - mproto)
	 elseif(2.5d0.le.mc .and. mc.lt.6.d0)then
	    fallback = (0.286d0*mc - 0.514d0)/(mt - mproto)
	 elseif(6.d0.le.mc .and. mc.lt.7.d0)then
	    fallback = 1.d0
	 elseif(7.d0.le.mc .and. mc.lt.11.d0)then
	    fallback = alpha_R*mc + beta_R
	 elseif(11.d0.le.mc)then
	    fallback = 1.d0
	 endif
*
      elseif(sne.eq.3)then
* Delayed
	 if(mc.lt.3.5d0)then
	    mproto = 1.2d0
	 elseif(3.5d0.le.mc .and. mc.lt.6.d0)then
	    mproto = 1.3d0
	 elseif(6.d0.le.mc .and. mc.lt.11.d0)then
	    mproto = 1.4d0
	 elseif(11.d0.le.mc)then
	    mproto = 1.6d0
	 endif
*
	 alpha_D = 0.133d0 - 0.093d0/(mt - mproto)
	 beta_D = 1.d0 - 11.d0*alpha_D
*	 
	 if(mc.lt.2.5d0)then
	    fallback = 0.2d0/(mt - mproto)
	 elseif(2.5d0.le.mc .and. mc.lt.3.5d0)then
	    fallback = (0.5d0*mc - 1.05d0)/(mt - mproto)
	 elseif(3.5d0.le.mc .and. mc.lt.11.d0)then
	    fallback = alpha_D*mc + beta_D
	 elseif(11.d0.le.mc)then
	    fallback = 1.d0
	 endif
*
      elseif(sne.eq.4)then
* Belczynski 2002
	 fallback = 0.d0
      elseif(sne.eq.5)then
* Only remnants
	 fallback = 0.d0
      else
         write(*,*) "Invalid SNe mechanism"
      endif
*
      return
**
      end

***
      SUBROUTINE deltat(kw,age,tm,tn,tscls,dt,dtr)
      implicit none
*
      INTEGER kw
      REAL*8 age,tm,tn,tscls(20)
      REAL*8 dt,dtr
      REAL*8 pts1,pts2,pts3
      COMMON /POINTS/ pts1,pts2,pts3
*
*     Base new time scale for changes in radius & mass on stellar type.
*
      if(kw.le.1)then
         dt = pts1*tm
         dtr = tm - age
      elseif(kw.eq.2)then
         dt = pts1*(tscls(1) - tm)
         dtr = tscls(1) - age
      elseif(kw.eq.3)then
         if(age.lt.tscls(6))then
            dt = pts2*(tscls(4) - age)
         else
            dt = pts2*(tscls(5) - age)
         endif
         dtr = MIN(tscls(2),tn) - age
      elseif(kw.eq.4)then
         dt = pts2*tscls(3)
         dtr = MIN(tn,tscls(2) + tscls(3)) - age
      elseif(kw.eq.5)then
         if(age.lt.tscls(9))then
            dt = pts3*(tscls(7) - age)
         else
            dt = pts3*(tscls(8) - age)
         endif
         dtr = MIN(tn,tscls(13)) - age
      elseif(kw.eq.6)then
         if(age.lt.tscls(12))then
            dt = pts3*(tscls(10) - age)
         else
            dt = pts3*(tscls(11) - age)
         endif
         dt = MIN(dt,0.005d0)
         dtr = tn - age
      elseif(kw.eq.7)then
         dt = pts1*tm
         dtr = tm - age
      elseif(kw.eq.8.or.kw.eq.9)then
         if(age.lt.tscls(6))then
            dt = pts2*(tscls(4) - age)
         else
            dt = pts2*(tscls(5) - age)
         endif
         dtr = tn - age
      else
*        dt = MAX(0.1d0,age*10.d0)
         dt = MAX(0.1d0,dt*10.d0)
         dt = MIN(dt,5.0d+02)
         dtr = dt
      endif
*
      RETURN
      END
***
